<?php

class BookingController extends Controller {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Booking::model()->clearDraft();
            Yii::app()->session['sidebar_active'] = 'booking';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $booking_car = Yii::app()->session['booking_car'];          //ทะเบียนรถ
        $booking_status = Yii::app()->session['booking_status'];    //สถานะ
        $booking_start_date = Yii::app()->session['booking_start_date'];      //จากวันใช้งาน
        $booking_end_date = Yii::app()->session['booking_end_date'];      //ถึงวันที่ใช้งาน

        $grids = $this->getGridData($booking_car, $booking_status, $booking_start_date, $booking_end_date);
        $this->render('index', array('grids' => $grids,
            'booking_status' => $booking_status,
            'booking_car' => $booking_car,
            'booking_start_date' => $booking_start_date,
            'booking_end_date' => $booking_end_date));
    }

    public function actionAjaxList() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        Yii::app()->session['booking_car'] = $_POST['txtsearch'];
        Yii::app()->session['booking_status'] = $_POST['booking_status'];
        Yii::app()->session['booking_start_date'] = $_POST['start_date'];
        Yii::app()->session['booking_end_date'] = $_POST['end_date'];

        $grids = $this->getGridData($_POST['txtsearch'], $_POST['booking_status'], $_POST['start_date'], $_POST['end_date'], $offset);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($booking_car = '', $booking_status = '', $booking_start_date = '', $booking_end_date = '', $offset = 0) {
        $sql = "SELECT tb_booking.id, tb_booking.docno, tb_booking.docdate, tb_booking.doctime,";
        $sql .= " tb_booking.start_date, tb_booking.end_date, tb_booking.status,";
        $sql .= " tb_car.code as car_code, tb_booking.person_name, ";
        $sql .= " tb_booking.working, tb_booking.status FROM tb_booking ";
        $sql .= " LEFT JOIN tb_car ON tb_booking.car_id = tb_car.id";
        $sql .= " Where (user_save_id='" . Yii::app()->user->id . "')";
        $sql .= " AND (tb_car.code LIKE '%$booking_car%' or tb_booking.docno LIKE '%$booking_car%' or tb_booking.working LIKE '%$booking_car%')";
        if ($booking_status != '') {
            if ($booking_status == '00') {
                $sql .= " AND (tb_booking.status='0' or tb_booking.status='1')";
            } else {
                $sql .= " AND tb_booking.status='$booking_status'";
            }
        }

        $booking_start_date = MyDate::dateToMysql($booking_start_date);
        $booking_end_date = MyDate::dateToMysql($booking_end_date);
        if ($booking_start_date == '')
            $booking_start_date = '0000-00-00';
        if ($booking_end_date == '')
            $booking_end_date = '3000-01-01';

        $sql .= " AND (";
        $sql .= " (date(tb_booking.start_date) between '$booking_start_date' AND '$booking_end_date')";
        $sql .= " OR (date(tb_booking.end_date) between '$booking_start_date' AND '$booking_end_date')";
        $sql .= " OR ('$booking_start_date' between date(tb_booking.start_date) AND date(tb_booking.end_date))";
        $sql .= " OR ('$booking_end_date' between date(tb_booking.start_date) AND date(tb_booking.end_date))";
        $sql .= ")";

        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxList';

        $pageLimit = Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql .= " Order By tb_booking.docno desc, tb_booking.start_date desc, tb_car.code asc";
        $sql .= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionCreate() {
        $this->render('search_car');
    }

    //แสดงรายการรถที่จะจอง
    public function actionAjaxListCar() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        $filter = array(
            'txtstatus' => $_POST['txtstatus'],
            'start_date' => MyDate::dateToMysql($_POST['start_date']) . " " . $_POST['start_time'],
            'end_date' => MyDate::dateToMysql($_POST['end_date']) . " " . $_POST['end_time'],
        );

        if ($filter['end_date'] <= $filter['start_date']) {
            $message = array(
                'start_date' => $_POST['start_date'] . " " . $_POST['start_time'],
                'end_date' => $_POST['end_date'] . " " . $_POST['end_time'],
            );
            $this->renderPartial('_error', array('message' => $message));
        } else {
            $grids = $this->getGridDataCar($filter, $offset);
            $this->renderPartial('_car_grid_view', array('grids' => $grids));
        }
    }

    public function getGridDataCar($filter, $offset = 0) {
        $sql = "
            DROP TEMPORARY TABLE IF EXISTS tmp_carbusy;
            CREATE TEMPORARY TABLE IF NOT EXISTS `tmp_carbusy` (
                `car_id` INT NULL ,
                `car_status` INT NULL ,
                `car_code` VARCHAR( 20 ) NULL ,
                `brand_name` VARCHAR( 200 ) NULL ,
                `model` VARCHAR( 200 ) NULL ,
                `cartype_name` VARCHAR( 200 ) NULL ,
                `oil_name` VARCHAR( 200 ) NULL ,
                `status` INT NULL ,
                `booking_status` INT NULL ,
                `seats` INT NULL ,
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY
            ) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            ";
        Yii::app()->db->createCommand($sql)->execute();

        $sql = "SELECT tb_car.id, tb_car.`code`, tb_brand.`name` as brand_name, tb_car.model, ";
        $sql .= " tb_cartype.`name` as cartype_name, tb_oil.name as oil_name, tb_car.status, tb_car.seats FROM tb_car ";
        $sql .= " LEFT JOIN tb_cartype ON tb_car.cartype_id = tb_cartype.id";
        $sql .= " LEFT JOIN tb_brand ON tb_car.brand_id = tb_brand.id";
        $sql .= " LEFT JOIN tb_oil on tb_car.oil_id = tb_oil.id";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $timeBefor = 0; //ต้องจองก่อนถึงเวลารถว่าง กี่นาทีแต่ในโปรแกรมไม่ได้ระบุไว้เลยกำหนดเป็น 0
        if ($timeBefor == 0) {
            $stime = '00:00:01';
            $etime = '-00:00:01';
        } else {
            $timeBefor--;
            $t = sprintf('%02d', $timeBefor);
            $stime = "-00:$t:00";
            $etime = "00:$t:00";
        }

        foreach ($models as $r) {
            $car_id = $r['id'];
            $car_code = $r['code'];
            $brand_name = $r['brand_name'];
            $car_model = $r['model'];
            $car_code = $r['code'];
            $cartype_name = $r['cartype_name'];
            $oil_name = $r['oil_name'];
            $car_status = $r['status'];
            $seats = $r['seats'];

            $sql = "select status from tb_booking where car_id='" . $car_id . "'";
            $sql .= " AND (";
            $sql .= " (ADDTIME(start_date, '$stime' ) between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
            $sql .= " OR (ADDTIME(end_date, '$etime') between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
            $sql .= " OR ('" . $filter['start_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
            $sql .= " OR ('" . $filter['end_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
            $sql .= ")";
            $rows = Yii::app()->db->createCommand($sql)->queryAll();

            $status = '0';  //0=ว่าง, 1=ไม่ว่าง สถานะที่ค้นหาได้ใน tbbooking
            $booking_status = 6;   //เพื่อเก็บสถานะว่าไม่ว่างเพราะอะไร แต่จะเอารายการหลังสุด
            foreach ($rows as $rw) {
                if ($rw['status'] == '0' || $rw['status'] == '1' || $rw['status'] == '2' || $rw['status'] == '9') {
                    $status = '1';
                    $booking_status = $rw['status'];   //เพื่อเก็บสถานะว่าไม่ว่างเพราะอะไร แต่จะเอารายการหลังสุด
                }
            }


            $sql = "insert into tmp_carbusy (car_id,car_code,brand_name,model,cartype_name,oil_name,status,car_status, booking_status, seats)";
            $sql .= " values ('$car_id','$car_code','$brand_name','$car_model','$cartype_name','$oil_name','$status','$car_status','$booking_status','$seats')";

            //$filter['txtstatus'] => 0=ว่าง, 1=ไม่ว่าง, 99=ทุกสถานะ
            if ($filter['txtstatus'] == '0' && $status == '0' && $car_status == '0') {
                //ว่าง
                Yii::app()->db->createCommand($sql)->execute();
            } else if ($filter['txtstatus'] == '1' && $status == '1' || $car_status != '0') {
                //ไม่ว่าง
                Yii::app()->db->createCommand($sql)->execute();
            } else if ($filter['txtstatus'] == '99') {
                //ทุกสถานะ
                Yii::app()->db->createCommand($sql)->execute();
            }
        }

        $sql = "select * from tmp_carbusy";
        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxListCar';

        $pageLimit = Yii::app()->params['pageSize'];
        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql .= " Order By car_code asc";
        $sql .= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionAjaxBusyDetail() {
        $car_id = $_POST['car_id'];
        $filter = array(
            'start_date' => MyDate::dateToMysql($_POST['start_date']) . " " . $_POST['start_time'],
            'end_date' => MyDate::dateToMysql($_POST['end_date']) . " " . $_POST['end_time'],
        );

        $timeBefor = 0; //ต้องจองก่อนถึงเวลารถว่าง กี่นาทีแต่ในโปรแกรมไม่ได้ระบุไว้เลยกำหนดเป็น 0
        if ($timeBefor == 0) {
            $stime = '00:00:01';
            $etime = '-00:00:01';
        } else {
            $timeBefor--;
            $t = sprintf('%02d', $timeBefor);
            $stime = "-00:$t:00";
            $etime = "00:$t:00";
        }

        $sql = "select tb_booking.*,tb_car.code as car_code, tb_depart.name as depart_name from tb_booking";
        $sql .= " LEFT JOIN tb_car on tb_booking.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart on tb_booking.depart_id = tb_depart.id";
        $sql .= " where (tb_booking.status = '0' or tb_booking.status='1' or tb_booking.status='2' or tb_booking.status='9')";
        $sql .= " AND (tb_booking.car_id='$car_id')";
        $sql .= " AND (";
        $sql .= " (ADDTIME(start_date, '$stime' ) between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
        $sql .= " OR (ADDTIME(end_date, '$etime') between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
        $sql .= " OR ('" . $filter['start_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
        $sql .= " OR ('" . $filter['end_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
        $sql .= ")";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $this->renderPartial('_detail_busy', array('models' => $models));
    }

    public function actionCreateDoc() {
        $model = new Booking;
        $model->docno = Docprefix::model()->getDocrun(1);
        $model->car_id = $_POST['car_id'];
        $model->docdate = date('Y-m-d');
        $model->doctime = date('H:i');
        $model->start_date = MyDate::dateToMySql($_POST['start_date']) . " " . $_POST['ddlStartH'] . ":" . $_POST['ddlStartM'];
        $model->end_date = MyDate::dateToMySql($_POST['end_date']) . " " . $_POST['ddlEndH'] . ":" . $_POST['ddlEndM'];

        $user = User::model()->findByPk(Yii::app()->user->id);
        $model->person_name = $user->title . $user->firstname . " " . $user->surname;
        $model->depart_id = $user->depart_id;
        $model->tel = $user->tel;

        $minute = MyDate::compareDate(array('begin' => $model->start_date, 'end' => $model->end_date), false);
        $car = Car::model()->findByPk($_POST['car_id']);
        $model->car_rate = $car->rate;
        $model->car_money = $car->rate * $minute;
        $model->status = '9';
        $model->user_save_id = Yii::app()->user->id;
        $model->date_create = date('Y-m-d H:i:s');

        $company = Company::model()->find();
        $model->time_expire = date('Y-m-d H:i:s', strtotime("+$company->booking_minute min"));  //เวลาหมดอายุทำรายการจอง

        $busy = Booking::model()->validateCarBusy($model->car_id, $model->start_date, $model->end_date);
        if ($busy != '99') {
            $msgText = "รถคันที่เลือกได้ถูกจองไปเมื่อไม่นานนี้ และอยู่ในขั้นตอน <strong><u>" . Booking::model()->getStatusText($busy) . "</u></strong><br/>จึงไม่สามารถจองได้ คุณต้องเลือกรถคันใหม่";
            Yii::app()->user->setFlash('text_error', $msgText);
            $this->redirect(array('booking/create'));
        } else {
            $model->save();

            //บันทึก Log
            $description = "<b>จองใช้รถ: </b>ยังไม่บันทึกข้อมูลจอง<br/>";
            $description .= "<b>ทะเบียน: </b>" . $car->code . " <b>เลขที่ใบจอง: </b>" . $model->docno . "<br/>";
            $description .= "<b>วันที่ใช้รถ: </b>" . $_POST['start_date'] . " " . $_POST['ddlStartH'] . ":" . $_POST['ddlStartM'];
            $description .= "<b>ถึงวันที่: </b>" . $_POST['end_date'] . " " . $_POST['ddlEndH'] . ":" . $_POST['ddlEndM'] . "<br/>";

            Userlog::model()->saveLog('002', $description);
            $this->redirect(array('update', 'id' => $model->id));
        }
    }

    public function actionAjaxValidate() {
        $model = new Booking;
        $data = $model->checkDuplicate($_POST['id'], $_POST['code']);

        /*
          $busy = Booking::model()->validateCarBusy($_POST['car_id'], $_POST['start_date'], $_POST['end_date']);
          if ($busy != '99') {
          $data['msgText'] = "รถคันที่เลือกได้ถูกจองไปเมื่อไม่นานนี้ และอยู่ในขั้นตอน <strong><u>" . Booking::model()->getStatusText($busy) . "</u></strong><br/>จึงไม่สามารถจองได้ คุณต้องเลือกรถคันใหม่";
          $data['msg'] = '1';
          }
         * 
         */
        echo CJSON::encode($data);
    }

    public function actionUpdate() {
        $id = (isset($_GET['id'])) ? (int) $_GET['id'] : '';
        $model = Booking::model()->findByPk($id);

        if (isset($_POST['Booking'])) {

            if ($_POST['id'] == '') {
                $model = new Booking;
                $model->date_create = date('Y-m-d H:i:s');
                $model->date_edit = date('Y-m-d H:i:s');
            } else {
                //submit มาจาก form
                $model = Booking::model()->findByPk($_POST['id']);
                $model->date_edit = date('Y-m-d H:i:s');
            }

            for ($i = 1; $i < 3; $i++) {
                if (isset($_FILES["file$i"])) {
                    $dir = Yii::getPathOfAlias("webroot.fileupload.booking");
                    $uploadedFile = CUploadedFile::getInstanceByName("file$i");
                    if ($uploadedFile !== null) {
                        $extName = $uploadedFile->getExtensionName();
                        if ($extName == 'php' || $extName == 'js' || $extName == 'exe' || $extName == 'bat') {
                            Yii::app()->user->setFlash('save_error', 'ไฟล์ที่อัพโหลดมีนามสกุลที่ต้องห้าม!..');
                            $this->redirect(array('update', 'id' => $model->id));
                            Yii::app()->end();
                        }

                        $org_name = explode('.', $uploadedFile->getName());
                        $new_name = $model->id . "_$i." . $extName;  //เปลี่ยนชื่อไฟล์

                        $uploadedFile->saveAs($dir . '/' . $new_name);
                        $file = "file$i";
                        $fileName = "file$i" . '_name';

                        $model->$fileName = $org_name[0] . ".$extName";
                        $model->$file = $new_name;
                    }
                }
            }

            $model->attributes = $_POST['Booking'];
            $model->docdate = date('Y-m-d');
            $model->doctime = date('H:i');
            $model->status = 0;
            $model->user_save_id = Yii::app()->user->id;
            $model->car_rate = MyFn::numberToMySql($model->car_rate);
            $model->car_money = MyFn::numberToMySql($model->car_money);

            if ($model->car_id == '') {
                $model->save_status = 1;
            } else {
                $model->save_status = 0;
            }

            if ($model->save()) {

                //บันทึก Log
                $car = Car::model()->findByPk($model->car_id);
                $description = "<b>จองใช้รถ: </b> บันทึกข้อมูลการจอง<br/>";
                $description .= "<b>ทะเบียน: </b>" . $car->code . ' <b>เลขที่ใบจอง: </b> ' . $model->docno . "<br/>";
                $description .= "<b>วันที่ใช้รถ: </b>" . MyDate::dateThai($model->start_date) . " " . date("H:i", strtotime($model->start_date)) . " <b>ถึงวันที่: </b>" . MyDate::dateThai($model->end_date) . " " . date("H:i", strtotime($model->end_date)) . "<br/>";
                $description .= "<b>จองใช้รถเพื่อ: </b>" . $model->working;
                Userlog::model()->saveLog('002', $description);

                Yii::app()->user->setFlash('success', 'บันทึกข้อมูลเรียบร้อย');
                $this->redirect(array('/booking'));
            } else {
                Yii::app()->user->setFlash('success', 'ไม่สามารถบันทึกข้อมูลได้เนื่องจาก ' . $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }
        $this->render('form', array('model' => $model));
    }

    public function actionAjaxDelete() {
        $msg = '0';
        $row = Booking::model()->findByPk($_POST['id']);
        $row->delete();

        //บันทึก Log
        $car = Car::model()->findByPk($row->car_id);
        $description = "<b>จองใช้รถ: </b> ลบรายการจอง<br/>";
        $description .= "<b>ทะเบียน: </b>" . $car->code . " <b>เลขที่ใบจอง: </b> " . $row->docno . "<br/>";
        $description .= "<b>วันที่ใช้รถ: </b>" . MyDate::dateThai($row->start_date) . " " . date("H:i", strtotime($row->start_date)) . " <b>ถึง: </b> " . MyDate::dateThai($row->end_date) . " " . date("H:i", strtotime($row->end_date)) . "<br/>";
        $description .= "<b>จองใช้รถเพื่อ: </b>" . $row->working;
        Userlog::model()->saveLog('002', $description);

        $data['msg'] = $msg;
        echo CJSON::encode($data);
    }

    //เปิด Modal เพื่อเลือกข้อมูล
    public function actionModal() {
        $this->layout = '//layouts/modalwindow/column1';
        $grids = $this->getGridDataModal();
        $this->render('modal', array('grids' => $grids));
    }

    public function actionAjaxListModal() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;
        $grids = $this->getGridDataModal($_POST['txtsearch'], $_POST['start_date'], $_POST['end_date'], $offset);
        $this->renderPartial('_gridview_modal', array('grids' => $grids));
    }

    public function getGridDataModal($booking_car = '', $booking_start_date = '', $booking_end_date = '', $offset = 0) {
        $sql = "SELECT tb_booking.id, tb_booking.docno, tb_booking.docdate, tb_booking.doctime,";
        $sql .= " tb_booking.start_date, tb_booking.end_date, tb_booking.status,";
        $sql .= " tb_car.code as car_code, tb_booking.person_name, ";
        $sql .= " tb_booking.working, tb_booking.status FROM tb_booking ";
        $sql .= " LEFT JOIN tb_car ON tb_booking.car_id = tb_car.id";
//        $sql .= " Where user_save_id='" . Yii::app()->user->id . "'";
//        $sql .= " AND (tb_car.code LIKE '%$booking_car%')";
//        $sql .= " AND tb_booking.status='2'";

        $sql .= " Where (tb_car.code LIKE '%$booking_car%')";
        if( Yii::app()->user->member_type!='1'){
            $sql .= " AND (user_save_id='" . Yii::app()->user->id . "')";
            $sql .= " AND (tb_booking.status='2')";
        }else{
             $sql .= " AND (tb_booking.status <> '9' AND tb_booking.status <> '00' AND tb_booking.status <> '3' AND tb_booking.status <> '4')";
        }

        if ($booking_start_date != '' && $booking_end_date != '') {
            $sql .= " AND (tb_booking.start_date >= '" . MyDate::dateToMysql($booking_start_date) . " 00:00:00'";
            $sql .= " AND tb_booking.end_date <= '" . MyDate::dateToMysql($booking_end_date) . " 23:59:59')";
        } else if ($booking_start_date != '' && $booking_end_date == '') {
            //กรอกแต่วันที่เริ่ม
            $sql .= " AND (tb_booking.start_date >= '" . MyDate::dateToMysql($booking_start_date) . "')";
        } else if ($booking_start_date == '' && $booking_end_date != '') {
            //กรอกแต่วันที่สิ้นสุด
            $sql .= " AND (tb_booking.end_date <= '" . MyDate::dateToMysql($booking_end_date) . "')";
        }

        $count = Yii::app()->db->createCommand($sql)->execute();
        $pages = new CPagination($count);
        $pages->route = 'ajaxListModal';

        $pageLimit = 7; //Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql .= " Order By tb_booking.docno, tb_booking.start_date, tb_booking.end_date, tb_car.code";
        $sql .= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    //พิมพ์ใบขออนุญาตใช้รถ
    public function actionPreview() {
        $id = (int) $_POST['booking_id'];

        $model = Booking::model()->findByPk($id);

        //แผนก
        $depart = Depart::model()->findByPk($model->depart_id);
        $depart_name = ($depart !== NULL) ? $depart->name : '';

        $car = Car::model()->getCarDetail($model->car_id);

        $caption = "แบบขออนุญาตใช้รถ";
        $tbl = "<div class='caption'>แบบขออนุญาตใช้รถ</div>";
        $tbl .= <<<EOD
<table style="overflow:wrap;" class='noborder'>
          <tbody>
EOD;
        $tbl .= "<tr><td align='right'><b>วันที่ </b>" . MyDate::dateThaiLong($model->docdate) . "</td></tr>";
        $tbl .= "<tr>";
        $tbl .= "<td><b>ข้าพเจ้า </b>{$this->setText($model->person_name, 5)}<b>แผนก </b>{$this->setText($depart_name, 5)}<b>โทรศัพท์ </b>{$this->setText($model->tel, 5)}</td>";
        $tbl .= "</tr>";
        $tbl .= "<tr>";
        $tbl .= "<td>";
        $tbl .= "<b>ขอใช้รถประเภท </b>{$this->setText($car['cartype_name'], 5)}<b>ยี่ห้อ </b>{$this->setText($car['brand_name'], 5)}<b>ทะเบียน </b>{$this->setText($car['code'], 5)}";
        $tbl .= "<b>ตั้งแต่วันที่ </b>{$this->setText(MyDate::dateThaiShort($model->start_date) . " เวลา " . date("H:i", strtotime($model->start_date)) . " น.", 0)}<b>ถึง </b>{$this->setText(MyDate::dateThaiShort($model->end_date) . " เวลา " . date("H:i", strtotime($model->end_date)) . " น.", 0)}";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "<tr>";
        $tbl .= "<td><b>สถานที่ปฏิบัติงาน </b>{$this->setText($model->address, 2)}<b>จองใช้รถเพื่อ </b>{$this->setText($model->working, 2)}</td>";
        $tbl .= "</tr>";
        if ($model->comment != '') {
            $tbl .= '<tr>';
            $tbl .= "<td><b>เพิ่มเติม </b>{$this->setText($model->comment, 2)}</td>";
            $tbl .= '</tr>';
        }
        $tbl .= "<tbody>";
        $tbl .= "</table><br/>";

        $tbl .= <<<EOD
<table style="overflow:wrap;" class='noborder'>
          <tbody>
EOD;
        $tbl .= "<tr>";
        $tbl .= "<td align='center'><b>ลงชื่อ</b>{$this->setText2('', 35)}<b>ผู้ขับ/ผู้รับรถ</b></td>";
        $tbl .= "<td align='center'><b>ลงชื่อ</b>{$this->setText2('', 35)}<b>ผู้มีอำนาจ</b></td>";
        $tbl .= "<td align='center'><b>ลงชื่อ</b>{$this->setText2('', 35)}<b>ผู้อนุมัติ</b></td>";
        $tbl .= "</td>";
        $tbl .= "<tr>";
        $tbl .= "<tr>";
        $tbl .= "<td align='center' valign='top'>(<b>{$this->setText2('', 45)}</b>)</td>";
        $tbl .= "<td align='center' valign='top'>(<b>{$this->setText2('', 45)}</b>)</td>";
        $tbl .= "<td align='center' valign='top'>(<b>&nbsp;" . $model->userApprove['firstname'] . ' ' . $model->userApprove['surname'] . "&nbsp;</b>)</td>";
        $tbl .= "</tr>";

        $tbl .= "<tbody>";
        $tbl .= "</table>";
        $tbl .= "<br/><b>โทรศัพท์พนักงานขับรถ: </b>" . $this->setText($model->driver['tel'], 2);


        $tbl .= <<<EOD
<table style="overflow:wrap;">
          <tbody>
EOD;
        $tbl .= "<tr><td align='center' colspan='2'><b>บันทึกของพนักงานรักษาความปลอดภัย</b></td></tr>";

        $tbl .= "<tr>";
        $tbl .= "<td>";
        $tbl .= "<b>นำรถออกวันที่ </b>.............../...................../.................... <b> เวลา </b>...............<b>น.</b><br/><br/>";
        $tbl .= "<b>เลขไมล์ก่อนใช้ </b>{$this->setText2('', 25)}<b> ลงชื่อ </b>{$this->setText2('', 30)}<b> รปภ.</b>";
        $tbl .= "</td>";
        $tbl .= "<td>";
        $tbl .= "<b>นำรถออกวันที่ </b>.............../...................../.................... <b> เวลา </b>...............<b>น.</b><br/><br/>";
        $tbl .= "<b>เลขไมล์หลังใช้ </b>{$this->setText2('', 25)}<b> ลงชื่อ </b>{$this->setText2('', 30)}<b> รปภ.</b>";
        $tbl .= "</td>";
        $tbl .= "</tr>";

        $tbl .= "<tr>";
        $tbl .= "<td>";
        $tbl .= "<b>บันทึกผู้ขับก่อนออกนอกสถานที่</b><br/>";
        $tbl .= "<p><b>ตรวจสภาพรถ </b>[ ] ปกติ&nbsp;&nbsp;&nbsp;&nbsp;[ ] ไม่ปกติ......................</p>";
        $tbl .= "<p><b>ตรวจความสะอาด </b>[ ] สะอาด&nbsp;&nbsp;&nbsp;&nbsp;[ ] ไม่สะอาด......................</p>";
        $tbl .= "<p><b>ตรวจสอบอุปกรณ์ </b>[ ] ยางอะไหล่&nbsp;&nbsp;&nbsp;[ ] แม่แรง&nbsp;&nbsp;&nbsp;[ ] เครื่องมือ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ ] ที่จุดบุหรี่</p>";

        $tbl .= "<br/><br/>";
        $tbl .= "ลงชื่อ.......................................................... ผู้ขอใช้/ผู้ขับ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;วันที่............../.............../...............<br/><br/>";
        $tbl .= "&nbsp;&nbsp;&nbsp;&nbsp;(..........................................................)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;เวลา.................น";
        $tbl .= "</td>";

        $tbl .= "<td>";
        $tbl .= "<b>บันทึกผู้รับรถหลังการส่งคืน</b><br/>";
        $tbl .= "<p><b>ตรวจสภาพรถ </b>[ ] ปกติ&nbsp;&nbsp;&nbsp;&nbsp;[ ] ไม่ปกติ......................</p>";
        $tbl .= "<p><b>ตรวจความสะอาด </b>[ ] สะอาด&nbsp;&nbsp;&nbsp;&nbsp;[ ] ไม่สะอาด......................</p>";
        $tbl .= "<p><b>ตรวจสอบอุปกรณ์ </b>[ ] ยางอะไหล่&nbsp;&nbsp;&nbsp;[ ] แม่แรง&nbsp;&nbsp;&nbsp;[ ] เครื่องมือ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ ] ที่จุดบุหรี่</p>";
        $tbl .= "<br/><br/>";
        $tbl .= "ลงชื่อ.......................................................... ผู้รับรถ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;วันที่............../.............../...............<br/><br/>";
        $tbl .= "&nbsp;&nbsp;&nbsp;&nbsp;(..........................................................)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;เวลา.................น";
        $tbl .= "</td>";
        $tbl .= "</tr>";

        $tbl .= "<tbody>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        //$content = $rpt->getSchoolName();
        $content = $tbl;

        $mpdf = $rpt->getMPDF("A4-L");
        $mpdf->WriteHTML($rpt->getCssPdf(), 1);
        $mpdf->WriteHTML($content, 2);
        $mpdf->Output();
    }

    public function setText($val, $space) {
        return "<span style='border-bottom:1px dotted'>&nbsp;&nbsp;" . $val . str_repeat('&nbsp;', $space) . "&nbsp;&nbsp;</span>&nbsp;&nbsp;";
    }

    public function setText2($val, $space) {
        return "<span style='border-bottom:1px dotted'>" . $val . str_repeat('&nbsp;', $space) . "</span>";
    }

    //ลบไฟล์แนบ
    public function actionAjaxDeleteFile() {
        $id = (int) $_POST['id'];
        $fileNumber = $_POST['fileNumber'];

        $file = "file$fileNumber";
        $fileName = "file$fileNumber" . "_name";
        $model = Booking::model()->findByPk($id);

        if ($model !== NULL) {
            $model->$file = '';
            $model->$fileName = '';
            if ($model->save()) {
                Booking::model()->deleteFile($id, $file);
            }
        }

        echo true;
    }

}
