<?php

class ImportController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'import';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $this->render('index');
    }

    public function actionProcess() {
        ini_set("memory_limit", "-1");
        ini_set("max_execution_time", "-1");

        $importStudent = array();

        if (isset($_FILES['file_upload'])) {
            $dir = Yii::getPathOfAlias("webroot.tmp");
            $uploadedFile = CUploadedFile::getInstanceByName('file_upload');
            if ($uploadedFile == null) {
                Yii::app()->user->setFlash('error', 'คุณต้องเลือกไฟล์ข้อมูลก่อน!!...');
                $this->redirect(array('import/index'));
            }

            $ext = $uploadedFile->getExtensionName();
            if ($ext != 'csv') {
                Yii::app()->user->setFlash('error', 'นามสกุลไฟล์ไม่ถูกต้อง ' . $ext);
                $this->redirect(array('import/index'));
            }

            // ข้อมูลที่ได้จากการใช้ Function file() จะได้ออกมาเป็น Array แต่ละบรรทัดข้อมูลที่เก็บใน File คือ 1 ค่า index ของ Array
            $file = $_FILES['file_upload']['tmp_name'];
            $data_txt = file(@$file);

            $this->createTempTable();

            $msg = '0';
            $msg_text = '';
            for ($i = 1; $i < count($data_txt); $i++) {  // วนรอบเพื่อแสดงผลขอ้มูล
                $exp = explode(",", $data_txt[$i]);
                $row = $i + 1;

                if (count($exp) != 11) {
                    $msg = '1';
                    $msg_text.= "<li>[บรรทัดที่ $row] กรอกข้อมูลไม่ครบ</li>";
                }

                $depart_code = trim(@$exp[0]);
                $depart = Depart::model()->findByAttributes(array('code' => "$depart_code"));
                //รหัสแผนก
                if ($depart === NULL) {
                    $msg = '1';
                    $msg_text.= "<li>[บรรทัดที่ $row] รหัสแผนก =>" . $depart_code . "<= ไม่มีอยู่ในระบบคุณต้องเพิ่มใน ข้อมูลพื้นฐานก่อน</li>";
                }

                //รหัสผู้ใช้
                if (trim(@$exp[1]) == '') {
                    $msg = '1';
                    $msg_text.= "<li>[บรรทัดที่ $row] <b>รหัสผู้ใช้</b> จะต้องไม่เป็นค่าว่าง</li>";
                } else {
                    $user = User::model()->findByAttributes(array('code' => $exp[1]));
                    if ($user !== NULL) {
                        $msg = '1';
                        $msg_text.= "<li>[บรรทัดที่ $row] รหัสผู้ใช้ =>" . $exp[1] . "<= มีในระบบแล้ว</li>";
                    }
                }

                //คำนำหน้าชื่อ
                if (trim(@$exp[2]) == '') {
                    $msg = '1';
                    $msg_text.= "<li>[บรรทัดที่ $row] <b>คำนำหน้าชื่อ</b>จะต้องไม่เป็นค่าว่าง</li>";
                }

                //ชื่อ
                if (trim(@$exp[3]) == '') {
                    $msg = '1';
                    $msg_text.= "<li>[บรรทัดที่ $row] ชื่อจะต้องไม่เป็นค่าว่าง</li>";
                }

                //นามสกุล
                if (trim(@$exp[4]) == '') {
                    $msg = '1';
                    $msg_text.= "<li>[บรรทัดที่ $row] นามสกุลจะต้องไม่เป็นค่าว่าง</li>";
                }

                //นามสกุล
                if (trim(@$exp[9]) == '') {
                    $msg = '1';
                    $msg_text.= "<li>[บรรทัดที่ $row] ชื่อเข้าใช้ระบบจะต้องไม่เป็นค่าว่าง</li>";
                } else {
                    $user = User::model()->findByAttributes(array('username' => $exp[9]));
                    if ($user !== NULL) {
                        $msg = '1';
                        $msg_text.= "<li>[บรรทัดที่ $row] ชื่อเข้าใช้ระบบ =>" . $exp[9] . "<= มีในระบบแล้ว</li>";
                    }
                }

                $code = trim(@$exp[1]);
                $title = trim(@$exp[2]);
                $firstname = trim(@$exp[3]);
                $surname = trim(@$exp[4]);
                $nickname = trim(@$exp[5]);
                $position_name = trim(@$exp[6]);
                $tel = trim(@$exp[7]);
                $email = trim(@$exp[8]);
                $username = trim(@$exp[9]);
                $password = trim(@$exp[10]);

                $sql = "insert into tmpimport(depart_code,code,title,firstname,surname,nickname,position_name,tel,email,username,password) values ";
                $sql.= " ('$depart_code','$code','$title','$firstname','$surname','$nickname','$position_name','$tel','$email','$username','$password')";
                Yii::app()->db->createCommand($sql)->execute();
            }
        }

        $models = Yii::app()->db->createCommand("select * from tmpimport")->queryAll();
        if ($msg == '1') {
            Yii::app()->user->setFlash('error', "<ul>$msg_text</ul>");
        }

        Yii::app()->session['tmpimport'] = $models;
        $this->render('index', array('models' => $models));
    }

    public function actionSaveProcess() {
        $models = Yii::app()->session['tmpimport'];
        foreach ($models as $r) {
            $code = $r['code'];
            $model = User::model()->findByAttributes(array('code' => "$code"));
            if ($model == NULL) {
                $depart = Depart::model()->findByAttributes(array('code' => $r['depart_code']));
                $model = new User();
                $model->member_type = '0';
                $model->code = $r['code'];
                $model->title = $r['title'];
                $model->firstname = $r['firstname'];
                $model->surname = $r['surname'];
                $model->nickname = $r['nickname'];
                $model->depart_id = $depart->id;
                $model->position_name = $r['position_name'];
                $model->tel = $r['tel'];
                $model->email = $r['email'];
                $model->status = '0';
                $model->username = $r['username'];
                if ($r['password'] == '') {
                    $password = MyFn::hashPassword("1234");
                } else {
                    $password = MyFn::hashPassword($r['password']);
                }
                $model->password = $password;
                $model->save();
            }
        }

        Yii::app()->user->setFlash('success', "Success: นำเข้าข้อมูลสำเร็จ");
        $this->redirect(array('import/index'));
    }

    //------ สร้างตารางชั่วคราว -------
    function createTempTable() {
        $sql = "DROP TABLE IF EXISTS `tmpimport`;
CREATE TABLE `tmpimport` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `depart_code` varchar(20) DEFAULT NULL,
  `code` varchar(20) DEFAULT NULL,
  `title` varchar(50) DEFAULT NULL,
  `firstname` varchar(50) DEFAULT NULL,
  `surname` varchar(50) DEFAULT NULL,
  `nickname` varchar(20) DEFAULT NULL,
  `position_name` varchar(100) DEFAULT NULL,
  `tel` varchar(100) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `username` varchar(20) DEFAULT NULL,
  `password` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SET FOREIGN_KEY_CHECKS = 1;";

        Yii::app()->db->createCommand($sql)->execute();
        return true;
    }

}
