<?php

/*
 * รายงานการใช้รถ
 */

class RptcarworkController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'report';

            if (!isset(Yii::app()->session['rptcarwork_start_date'])) {
                Yii::app()->session['rptcarwork_start_date'] = MyDate::dateToText(date('Y-m-d'));
                Yii::app()->session['rptcarwork_end_date'] = MyDate::dateToText(date('Y-m-d'));
            }
            Yii::app()->session['report_tab'] = 'tab2';
            return true;
        }
        return false;
    }

    //รายงานการใช้รถ
    public function actionIndex() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.start_km, tb_carwork.end_km, tb_carwork.driver_id, tb_carwork.person_name";
        $sql .= " FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานการใช้รถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='80' rowspan='2'>เลขที่เอกสาร</th>
          <th width='70' rowspan='2'>ทะเบียน</th>
          <th colspan='2'>วันเดินทาง</th>
          <th width='110' rowspan='2'>ผู้ใช้รถ</th>
          <th rowspan='2'>ใช้รถเพื่อ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>ก่อนใช้</th>
          <th colspan='2'>วันกลับ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>หลังใช้</th>
          <th width='45' rowspan='2'>รวม<br/>ระยะทาง</th>
          <th width='110' rowspan='2'>พนักงาน<br/>ขับรถ</th>
          <th width='50' rowspan='2'>หมายเหตุ</th>
          </tr>
          <tr>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;

        foreach ($models as $r) {
            $driver_name = '';
            $driver = Driver::model()->findByPk($r['driver_id']);
            if ($driver != NULL) {
                $driver_name = $driver->title . $driver->firstname . " " . $driver->surname;
            }

            $km = $r['end_km'] - $r['start_km'];
            $irow++;
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['start_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['start_time'])) . "</td>";
            $tbl .= "<td>" . $r['person_name'] . "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['start_km']) . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['end_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['end_time'])) . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['end_km']) . "</td>";
            $tbl .= "<td align='center'>" . number_format($km) . "</td>";
            $tbl .= "<td>$driver_name</td>";
            $tbl .= "<td></td>";
            $tbl .= "</tr>";
        }

        if ($irow == 0) {
            $tbl .= "<tr><td colspan='13' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        } else {
            $tbl .= "<tr><td colspan='13' align='center' class='bold'>รวมทั้งหมด " . number_format($irow) . " รายการ</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";
        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานการใช้รถ-ตามหน่วยงาน
    public function actionFaculty() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork_faculty', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionFacultyPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $faculty = (isset($_POST['duallistbox_faculty'])) ? implode(",", $_POST['duallistbox_faculty']) : '';
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.start_km, tb_carwork.end_km, tb_carwork.driver_id, tb_carwork.person_name,";
        $sql .= " tb_depart.faculty_id, tb_faculty.name as faculty_name FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";
        $sql .= " LEFT JOIN tb_faculty ON tb_depart.faculty_id = tb_faculty.id";
        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        if ($faculty != '') {
            $sql .= " AND (tb_depart.faculty_id in($faculty))";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_faculty.name asc, tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานการใช้รถ-ตามหน่วยงาน";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='80' rowspan='2'>เลขที่เอกสาร</th>
          <th width='70' rowspan='2'>ทะเบียน</th>
          <th colspan='2'>วันเดินทาง</th>
          <th width='110' rowspan='2'>ผู้ใช้รถ</th>
          <th rowspan='2'>ใช้รถเพื่อ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>ก่อนใช้</th>
          <th colspan='2'>วันกลับ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>หลังใช้</th>
          <th width='45' rowspan='2'>รวม<br/>ระยะทาง</th>
          <th width='110' rowspan='2'>พนักงาน<br/>ขับรถ</th>
          <th width='50' rowspan='2'>หมายเหตุ</th>
          </tr>
          <tr>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_fac = 0;
        $faculty_id = '';

        foreach ($models as $r) {
            if ($faculty_id != $r['faculty_id']) {
                if ($irow_fac > 0) {
                    $tbl .= "<tr>";
                    $tbl .= "<td colspan='13' align='center'><b>รวม " . number_format($irow_fac) . " รายการ</b></td>";
                    $tbl .= "</tr>";
                    $irow_fac = 0;
                }
                $tbl .= "<tr>";
                $tbl .= "<td colspan='13'><br/><strong>หน่วยงาน: " . $r['faculty_name'] . "<strong></td>";
                $tbl .= "</tr>";
            }

            $driver_name = '';
            $driver = Driver::model()->findByPk($r['driver_id']);
            if ($driver != NULL) {
                $driver_name = $driver->title . $driver->firstname . " " . $driver->surname;
            }

            $km = $r['end_km'] - $r['start_km'];
            $irow++;

            $irow_fac++;
            $faculty_id = $r['faculty_id'];

            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['start_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['start_time'])) . "</td>";
            $tbl .= "<td>" . $r['person_name'] . "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['start_km']) . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['end_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['end_time'])) . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['end_km']) . "</td>";
            $tbl .= "<td align='center'>" . number_format($km) . "</td>";
            $tbl .= "<td>$driver_name</td>";
            $tbl .= "<td></td>";
            $tbl .= "</tr>";
        }

        if ($irow_fac > 0) {
            $tbl .= "<tr>";
            $tbl .= "<td colspan='13' align='center'><b>รวม " . number_format($irow_fac) . " รายการ</b></td>";
            $tbl .= "</tr>";
        }
        if ($irow == 0) {
            $tbl .= "<tr><td colspan='13' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        } else {
            $tbl .= "<tr><td colspan='13' align='center' class='bold'>รวมทั้งหมด " . number_format($irow) . " รายการ</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";
        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานการใช้รถ-ตามแผนก
    public function actionDepart() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork_depart', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionDepartPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $depart = (isset($_POST['duallistbox_depart'])) ? implode(",", $_POST['duallistbox_depart']) : '';
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.start_km, tb_carwork.end_km, tb_carwork.driver_id, tb_carwork.person_name,";
        $sql .= " tb_carwork.depart_id, tb_depart.name as depart_name FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";
        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        if ($depart != '') {
            $sql .= " AND (tb_depart.id in($depart))";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_depart.name asc, tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานการใช้รถ-ตามแผนก";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='80' rowspan='2'>เลขที่เอกสาร</th>
          <th width='70' rowspan='2'>ทะเบียน</th>
          <th colspan='2'>วันเดินทาง</th>
          <th width='110' rowspan='2'>ผู้ใช้รถ</th>
          <th rowspan='2'>ใช้รถเพื่อ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>ก่อนใช้</th>
          <th colspan='2'>วันกลับ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>หลังใช้</th>
          <th width='45' rowspan='2'>รวม<br/>ระยะทาง</th>
          <th width='110' rowspan='2'>พนักงาน<br/>ขับรถ</th>
          <th width='50' rowspan='2'>หมายเหตุ</th>
          </tr>
          <tr>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_depart = 0;
        $depart_id = '';

        foreach ($models as $r) {
            if ($depart_id != $r['depart_id']) {
                if ($irow_depart > 0) {
                    $tbl .= "<tr>";
                    $tbl .= "<td colspan='13' align='center'><b>รวม " . number_format($irow_depart) . " รายการ</b></td>";
                    $tbl .= "</tr>";

                    $irow_depart = 0;
                }

                $depart_name = ($r['depart_name'] == null) ? '<span style="color:#d3d3d3">แผนกนี้ถูกลบออกจากระบบ</span>' : $r['depart_name'];
                $tbl .= "<tr>";
                $tbl .= "<td colspan='13'><br/><strong>แผนก: $depart_name<strong></td>";
                $tbl .= "</tr>";
            }

            $depart_id = $r['depart_id'];
            $irow_depart++;

            $driver_name = '';
            $driver = Driver::model()->findByPk($r['driver_id']);
            if ($driver != NULL) {
                $driver_name = $driver->title . $driver->firstname . " " . $driver->surname;
            }

            $km = $r['end_km'] - $r['start_km'];
            $irow++;
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['start_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['start_time'])) . "</td>";
            $tbl .= "<td>" . $r['person_name'] . "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['start_km']) . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['end_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['end_time'])) . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['end_km']) . "</td>";
            $tbl .= "<td align='center'>" . number_format($km) . "</td>";
            $tbl .= "<td>$driver_name</td>";
            $tbl .= "<td></td>";
            $tbl .= "</tr>";
        }

        if ($irow_depart > 0) {
            $tbl .= "<tr>";
            $tbl .= "<td colspan='13' align='center'><b>รวม " . number_format($irow_depart) . " รายการ</b></td>";
            $tbl .= "</tr>";
        }

        if ($irow == 0) {
            $tbl .= "<tr><td colspan='13' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        } else {
            $tbl .= "<tr><td colspan='13' align='center' class='bold'>รวมทั้งหมด " . number_format($irow) . " รายการ</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";
        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานการใช้รถ-ตามทะเบียนรถ
    public function actionTabian() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork_tabian', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionTabianPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $tabian = (isset($_POST['duallistbox_tabian'])) ? implode(",", $_POST['duallistbox_tabian']) : '';

        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.start_km, tb_carwork.end_km, tb_carwork.driver_id, tb_carwork.person_name,";
        $sql .= " tb_carwork.car_id FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        if ($tabian != '') {
            $sql .= " AND (tb_carwork.car_id in($tabian))";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_car.code asc, tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานการใช้รถ-ตามทะเบียนรถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='80' rowspan='2'>เลขที่เอกสาร</th>
          <th width='70' rowspan='2'>ทะเบียน</th>
          <th colspan='2'>วันเดินทาง</th>
          <th width='110' rowspan='2'>ผู้ใช้รถ</th>
          <th rowspan='2'>ใช้รถเพื่อ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>ก่อนใช้</th>
          <th colspan='2'>วันกลับ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>หลังใช้</th>
          <th width='45' rowspan='2'>รวม<br/>ระยะทาง</th>
          <th width='110' rowspan='2'>พนักงาน<br/>ขับรถ</th>
          <th width='50' rowspan='2'>หมายเหตุ</th>
          </tr>
          <tr>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_car = 0;
        $car_id = '';


        foreach ($models as $r) {
            if ($car_id != $r['car_id']) {
                if ($irow_car > 0) {
                    $tbl .= "<tr>";
                    $tbl .= "<td colspan='13 align='center'><b>รวม " . number_format($irow_car) . " รายการ</b></td>";
                    $tbl .= "</tr>";

                    $irow_car = 0;
                }
                $tbl .= "<tr>";
                $tbl .= "<td colspan='13'><br/><strong>ทะเบียน: " . $r['car_code'] . "<strong></td>";
                $tbl .= "</tr>";
            }

            $irow_car++;
            $car_id = $r['car_id'];

            $driver_name = '';
            $driver = Driver::model()->findByPk($r['driver_id']);
            if ($driver != NULL) {
                $driver_name = $driver->title . $driver->firstname . " " . $driver->surname;
            }

            $km = $r['end_km'] - $r['start_km'];
            $irow++;
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['start_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['start_time'])) . "</td>";
            $tbl .= "<td>" . $r['person_name'] . "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['start_km']) . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['end_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['end_time'])) . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['end_km']) . "</td>";
            $tbl .= "<td align='center'>" . number_format($km) . "</td>";
            $tbl .= "<td>$driver_name</td>";
            $tbl .= "<td></td>";
            $tbl .= "</tr>";
        }

        if ($irow_car > 0) {
            $tbl .= "<tr>";
            $tbl .= "<td colspan='13 align='center'><b>รวม " . number_format($irow_car) . " รายการ</b></td>";
            $tbl .= "</tr>";
        }

        if ($irow == 0) {
            $tbl .= "<tr><td colspan='13' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        } else {
            $tbl .= "<tr><td colspan='13' align='center' class='bold'>รวมทั้งหมด " . number_format($irow) . " รายการ</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานสรุปจำนวนการใช้รถ
    public function actionSummary() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork_summary', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionSummaryPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        //สร้างตารางชั่วคราว
        $sql = "
            DROP TEMPORARY TABLE IF EXISTS tmp_summary;
            CREATE TEMPORARY TABLE IF NOT EXISTS `tmp_summary` (
                `faculty_id` INT NULL ,
                `depart_id` INT NULL ,
                `faculty_name` VARCHAR( 200 ) NULL ,
                `depart_name` VARCHAR( 200 ) NULL ,
                `count_row` INT NULL ,
                `count_day` float NULL ,
                `km` float NULL ,
                `amount_oil` float NULL DEFAULT 0 ,
                `oil_money` float NULL DEFAULT 0 ,
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY
            ) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            ";
        Yii::app()->db->createCommand($sql)->execute();

        $sql = "SELECT tb_carwork.id,tb_carwork.start_date, tb_carwork.end_date,";
        $sql .= " tb_car.code as car_code, tb_carwork.person_name, tb_depart.name as depart_name, tb_carwork.depart_id,";
        $sql .= " tb_depart.faculty_id, tb_faculty.name as faculty_name,";
        $sql .= " tb_carwork.start_time, tb_carwork.end_time,tb_carwork.start_km, tb_carwork.end_km, ";
        $sql .= " tb_carwork.amount_oil, tb_carwork.oil_rate FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";
        $sql .= " LEFT JOIN tb_faculty ON tb_depart.faculty_id = tb_faculty.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_depart.name asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        foreach ($models as $r) {
            $ts1 = strtotime($r['start_date'] . " " . $r['start_time']);
            $ts2 = strtotime($r['end_date'] . " " . $r['end_time']);
            $seconds_diff = $ts2 - $ts1;
            $count_day = ($seconds_diff / 3600 / 24);

            $amount_oil = (float) $r['amount_oil'];
            $oil_rate = (float) $r['oil_rate'];

            $km = $r['end_km'] - $r['start_km'];
            $oil_money = $amount_oil * $oil_rate;

            $faculty_id = ($r['faculty_id'] == null) ? 0 : $r['faculty_id'];
            $faculty_name = ($r['faculty_name'] == null) ? 'หน่วยงานนี้ถูกลบออกจากระบบ' : $r['faculty_name'];
            $depart_id = ( $r['depart_id'] == null) ? 0 : $r['depart_id'];
            $depart_name = ($r['depart_name'] == null) ? 'แผนกนี้ถูกลบออกจากระบบ' : $r['depart_name'];

            $sql = "insert into tmp_summary (faculty_id,depart_id,faculty_name,depart_name,count_row,count_day,km,amount_oil,oil_money) values ";
            $sql .= " ('" . $faculty_id . "','" . $depart_id . "','" . $faculty_name . "','" . $depart_name . "',";
            $sql .= " 1,$count_day,$km,'" . $amount_oil . "',$oil_money)";
            Yii::app()->db->createCommand($sql)->execute();
        }

        $sql = "SELECT tmp_summary.faculty_id, 
	tmp_summary.depart_id, 
	tmp_summary.faculty_name, 
	tmp_summary.depart_name, 
	sum(tmp_summary.count_row) AS sumrow, 
	sum(tmp_summary.count_day) AS sumday,
        sum(tmp_summary.km) AS sumkm,
        sum(tmp_summary.amount_oil) AS sumamount_oil,
        sum(tmp_summary.oil_money) AS sumoil_money
FROM tmp_summary
GROUP BY faculty_id,depart_id,faculty_name,depart_name
ORDER BY tmp_summary.faculty_name ASC, tmp_summary.depart_name ASC";

        $models = Yii::app()->db->createCommand($sql)->queryAll();
        $caption = "รายงานสรุปจำนวนการใช้รถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'><strong>ระหว่างวันที่</strong> " . MyDate::dateThai($start_date) . " <strong>ถึง</strong> " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;">
          <thead>
          <tr>            
          <th>แผนก</th>
          <th width='80'>จำนวนครั้ง</th>
          <th width='100'>จำนวนวัน</th>
          <th width='100'>ระยะทาง (km)</th>
          <th width='100'>น้ำมัน (ลิตร)</th>
          <th width='100'>น้ำมัน (บาท)</th>   
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_fac = 0;
        $faculty_id = '';
        $sumrow = 0;
        $sumday = 0;

        $sumkm = 0;
        $sumoil = 0;
        $sumoil_money = 0;

        $totalrow = 0;
        $totalday = 0;

        $totalkm = 0;
        $totaloil = 0;
        $totaloil_money = 0;
        foreach ($models as $r) {
            if ($faculty_id != $r['faculty_id']) {
                if ($irow_fac > 0) {
                    $tbl .= "<tr>";
                    $tbl .= "<td align='right'><b><i>รวม:</i></b></td>";
                    $tbl .= "<td align='center'><b>$sumrow</b></td>";
                    $tbl .= "<td align='center'><b>" . number_format($sumday, 2) . "</b></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sumkm) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sumoil, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sumoil_money, 2) . "</td>";
                    $tbl .= "</tr>";
                    $irow_fac = 0;
                    $sumrow = 0;
                    $sumday = 0;

                    $sumkm = 0;
                    $sumoil = 0;
                    $sumoil_money = 0;
                }
                $tbl .= "<tr>";
                $tbl .= "<td colspan='6'><br/><strong>หน่วยงาน: " . $r['faculty_name'] . "<strong></td>";
                $tbl .= "</tr>";
            }

            $faculty_id = $r['faculty_id'];
            $irow_fac++;
            $irow++;

            $sumrow += $r['sumrow'];
            $sumday += $r['sumday'];
            $totalrow += $r['sumrow'];
            $totalday += $r['sumday'];

            $sumkm += $r['sumkm'];
            $sumoil += $r['sumamount_oil'];
            $sumoil_money += $r['sumoil_money'];
            $totalkm += $r['sumkm'];
            $totaloil += $r['sumamount_oil'];
            $totaloil_money += $r['sumoil_money'];

            $tbl .= "<tr>";
            $tbl .= "<td>" . $r['depart_name'] . "</td>";
            $tbl .= "<td align='center'>" . $r['sumrow'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['sumday'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumkm']) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumamount_oil'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumoil_money'], 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow_fac > 0) {
            $tbl .= "<tr>";
            $tbl .= "<td align='right'><b><i>รวม:</i></b></td>";
            $tbl .= "<td align='center'><b>$sumrow</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($sumday, 2) . "</b></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sumkm) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sumoil, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sumoil_money, 2) . "</td>";
            $tbl .= "</tr>";

            $tbl .= "<tr>";
            $tbl .= "<td align='right'><b>รวมทั้งหมด:</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalrow) . "</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalday, 2) . "</b></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalkm) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totaloil, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totaloil_money, 2) . "</td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='6' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }


        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานสรุปจำนวนการใช้รถ-ตามทะเบียนรถ
    public function actionTabianSummary() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork_tabian_summary', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionTabianSummaryPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        //สร้างตารางชั่วคราว
        $sql = "
            DROP TEMPORARY TABLE IF EXISTS tmp_tabiansummary;
            CREATE TEMPORARY TABLE IF NOT EXISTS `tmp_tabiansummary` (
                `car_code` VARCHAR( 20 ) NULL ,
                `count_row` INT NULL ,
                `count_day` float NULL ,
                `km` float NULL ,
                `amount_oil` float NULL ,
                `oil_money` float NULL ,
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY
            ) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            ";
        Yii::app()->db->createCommand($sql)->execute();

        $sql = "SELECT tb_carwork.id,tb_car.code as car_code,tb_carwork.start_date,tb_carwork.end_date,";
        $sql .= " tb_carwork.start_time, tb_carwork.end_time,tb_carwork.start_km, tb_carwork.end_km, ";
        $sql .= " tb_carwork.amount_oil, tb_carwork.oil_rate FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_car.code asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        foreach ($models as $r) {
            $ts1 = strtotime($r['start_date'] . " " . $r['start_time']);
            $ts2 = strtotime($r['end_date'] . " " . $r['end_time']);
            $seconds_diff = $ts2 - $ts1;
            $count_day = ($seconds_diff / 3600 / 24);

            $km = $r['end_km'] - $r['start_km'];

            $amount_oil = (float) $r['amount_oil'];
            $oil_rate = (float) $r['oil_rate'];

            $oil_money = $amount_oil * $oil_rate;


            $sql = "insert into tmp_tabiansummary (car_code,count_row,count_day,km,amount_oil,oil_money) values ";
            $sql .= " ('" . $r['car_code'] . "',1,$count_day,$km,'" . $amount_oil . "',$oil_money)";
            Yii::app()->db->createCommand($sql)->execute();
        }

        $sql = "SELECT tmp_tabiansummary.car_code, 
	sum(tmp_tabiansummary.count_row) AS sumrow, 
	sum(tmp_tabiansummary.count_day) AS sumday,
        sum(tmp_tabiansummary.km) AS sumkm,
        sum(tmp_tabiansummary.amount_oil) AS sumamount_oil,
        sum(tmp_tabiansummary.oil_money) AS sumoil_money
FROM tmp_tabiansummary
GROUP BY car_code
ORDER BY tmp_tabiansummary.car_code ASC";

        $models = Yii::app()->db->createCommand($sql)->queryAll();
        $caption = "รายงานสรุปจำนวนการใช้รถ-ตามทะเบียนรถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'><strong>ระหว่างวันที่</strong> " . MyDate::dateThai($start_date) . " <strong>ถึง</strong> " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;">
          <thead>
          <tr>            
          <th>ทะเบียนรถ</th>
          <th width='80'>จำนวนครั้ง</th>
          <th width='100'>จำนวนวัน</th>
          <th width='100'>ระยะทาง (km)</th>
          <th width='100'>น้ำมัน (ลิตร)</th>
          <th width='100'>น้ำมัน (บาท)</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $totalrow = 0;
        $totalday = 0;
        $totalkm = 0;
        $totaloil = 0;
        $totaloil_money = 0;
        foreach ($models as $r) {
            $irow++;

            $totalrow += $r['sumrow'];
            $totalday += $r['sumday'];
            $totalkm += $r['sumkm'];
            $totaloil += $r['sumamount_oil'];
            $totaloil_money += $r['sumoil_money'];

            $tbl .= "<tr>";
            $tbl .= "<td>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>" . $r['sumrow'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['sumday'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumkm']) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumamount_oil'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumoil_money'], 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $tbl .= "<tr>";
            $tbl .= "<td align='right'><b>รวมทั้งหมด:</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalrow) . "</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalday, 2) . "</b></td>";
            $tbl .= "<td align='right'><b>" . number_format($totalkm) . "</b></td>";
            $tbl .= "<td align='right'><b>" . number_format($totaloil, 2) . "</b></td>";
            $tbl .= "<td align='right'><b>" . number_format($totaloil_money, 2) . "</b></td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='3' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานการใช้รถ-ตามพนักงานขับรถ
    public function actionDriver() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork_driver', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionDriverPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $driver_id = (isset($_POST['duallistbox_driver'])) ? implode(",", $_POST['duallistbox_driver']) : '';

        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.start_km, tb_carwork.end_km, ifnull(tb_carwork.driver_id, 0) as driver_id, tb_carwork.person_name,";
        $sql .= " tb_carwork.car_id FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        if ($driver_id != '') {
            $sql .= " AND (tb_carwork.driver_id in($driver_id))";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by ifnull(tb_carwork.driver_id, 0) asc, tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานการใช้รถ-ตามพนักงานขับรถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='80' rowspan='2'>เลขที่เอกสาร</th>
          <th width='70' rowspan='2'>ทะเบียน</th>
          <th colspan='2'>วันเดินทาง</th>
          <th width='110' rowspan='2'>ผู้ใช้รถ</th>
          <th rowspan='2'>ใช้รถเพื่อ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>ก่อนใช้</th>
          <th colspan='2'>วันกลับ</th>
          <th width='50' rowspan='2'>เลขไมล์<br/>หลังใช้</th>
          <th width='45' rowspan='2'>รวม<br/>ระยะทาง</th>
          <th width='50' rowspan='2'>หมายเหตุ</th>
          </tr>
          <tr>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          <th width='55'>วันที่</th>
          <th width='35'>เวลา</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_driver = 0;
        $driver_id = 'xx';
        foreach ($models as $r) {
            if ($driver_id != $r['driver_id']) {
                if ($irow_driver > 0) {
                    $tbl .= "<tr>";
                    $tbl .= "<td colspan='12 align='center'><b>รวม " . number_format($irow_driver) . " รายการ</b></td>";
                    $tbl .= "</tr>";

                    $irow_driver = 0;
                }

                $driver_name = '<span style="color:#d3d3d3">ไม่มีพนักงานขับรถ</span>';
                $driver = Driver::model()->findByPk((int) $r['driver_id']);
                if ($driver !== NULL) {
                    $driver_name = $driver->title . $driver->firstname . " " . $driver->surname;
                }
                $tbl .= "<tr>";
                $tbl .= "<td colspan='12'><br/><strong>พนักงานขับรถ: $driver_name<strong></td>";
                $tbl .= "</tr>";
            }

            $irow_driver++;
            $driver_id = $r['driver_id'];

            $km = $r['end_km'] - $r['start_km'];
            $irow++;
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['start_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['start_time'])) . "</td>";
            $tbl .= "<td>" . $r['person_name'] . "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['start_km']) . "</td>";
            $tbl .= "<td align='center'>" . MyDate::dateThai($r['end_date'], true) . "</td>";
            $tbl .= "<td align='center'>" . date("H:i", strtotime($r['end_time'])) . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['end_km']) . "</td>";
            $tbl .= "<td align='center'>" . number_format($km) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "</tr>";
        }

        if ($irow_driver > 0) {
            $tbl .= "<tr>";
            $tbl .= "<td colspan='12 align='center'><b>รวม " . number_format($irow_driver) . " รายการ</b></td>";
            $tbl .= "</tr>";
        }

        if ($irow == 0) {
            $tbl .= "<tr><td colspan='12' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        } else {
            $tbl .= "<tr><td colspan='12' align='center' class='bold'>รวมทั้งหมด " . number_format($irow) . " รายการ</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานสรุปจำนวนการใช้รถ-ตามพนักงานขับรถ
    public function actionDriverSummary() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptcarwork_driver_summary', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionDriverSummaryPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        //สร้างตารางชั่วคราว
        $sql = "
            DROP TEMPORARY TABLE IF EXISTS tmp_tabiansummary;
            CREATE TEMPORARY TABLE IF NOT EXISTS `tmp_tabiansummary` (
                `driver_id` INT NULL ,
                `count_row` INT NULL ,
                `count_day` float NULL ,
                `km` float NULL ,
                `amount_oil` float NULL ,
                `oil_money` float NULL ,
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY
            ) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            ";
        Yii::app()->db->createCommand($sql)->execute();

        $sql = "SELECT tb_carwork.id,tb_carwork.start_date,tb_carwork.end_date,";
        $sql .= " tb_carwork.start_time, tb_carwork.end_time,tb_carwork.start_km, tb_carwork.end_km, ";
        $sql .= " tb_carwork.amount_oil, tb_carwork.oil_rate, ifnull(tb_carwork.driver_id, 0) as driver_id FROM tb_carwork ";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by ifnull(tb_carwork.driver_id, 0) asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        foreach ($models as $r) {
            $ts1 = strtotime($r['start_date'] . " " . $r['start_time']);
            $ts2 = strtotime($r['end_date'] . " " . $r['end_time']);
            $seconds_diff = $ts2 - $ts1;
            $count_day = ($seconds_diff / 3600 / 24);

            $km = $r['end_km'] - $r['start_km'];

            $amount_oil = (float) $r['amount_oil'];
            $oil_rate = (float) $r['oil_rate'];
            $oil_money = $amount_oil * $oil_rate;


            $sql = "insert into tmp_tabiansummary (driver_id,count_row,count_day,km,amount_oil,oil_money) values ";
            $sql .= " ('" . $r['driver_id'] . "',1,$count_day,$km,'" . $amount_oil . "',$oil_money)";
            Yii::app()->db->createCommand($sql)->execute();
        }

        $sql = "SELECT tmp_tabiansummary.driver_id, 
	sum(tmp_tabiansummary.count_row) AS sumrow, 
	sum(tmp_tabiansummary.count_day) AS sumday,
        sum(tmp_tabiansummary.km) AS sumkm,
        sum(tmp_tabiansummary.amount_oil) AS sumamount_oil,
        sum(tmp_tabiansummary.oil_money) AS sumoil_money
FROM tmp_tabiansummary
GROUP BY driver_id
ORDER BY tmp_tabiansummary.driver_id ASC";

        $models = Yii::app()->db->createCommand($sql)->queryAll();
        $caption = "รายงานสรุปจำนวนการใช้รถ-ตามพนักงานขับ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'><strong>ระหว่างวันที่</strong> " . MyDate::dateThai($start_date) . " <strong>ถึง</strong> " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;">
          <thead>
          <tr>            
          <th>พนักงานขับรถ</th>
          <th width='80'>จำนวนครั้ง</th>
          <th width='100'>จำนวนวัน</th>
          <th width='100'>ระยะทาง (km)</th>
          <th width='100'>น้ำมัน (ลิตร)</th>
          <th width='100'>น้ำมัน (บาท)</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $totalrow = 0;
        $totalday = 0;
        $totalkm = 0;
        $totaloil = 0;
        $totaloil_money = 0;
        foreach ($models as $r) {
            $irow++;

            $totalrow += $r['sumrow'];
            $totalday += $r['sumday'];
            $totalkm += $r['sumkm'];
            $totaloil += $r['sumamount_oil'];
            $totaloil_money += $r['sumoil_money'];

            $driver_name = '<span style="color:#d3d3d3">ไม่มีพนักงานขับรถ</span>';
            $driver = Driver::model()->findByPk((int) $r['driver_id']);
            if ($driver !== NULL) {
                $driver_name = $driver->title . $driver->firstname . " " . $driver->surname;
            }

            $tbl .= "<tr>";
            $tbl .= "<td>$driver_name</td>";
            $tbl .= "<td align='center'>" . $r['sumrow'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['sumday'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumkm']) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumamount_oil'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumoil_money'], 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $tbl .= "<tr>";
            $tbl .= "<td align='right'><b>รวมทั้งหมด:</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalrow) . "</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalday, 2) . "</b></td>";
            $tbl .= "<td align='right'><b>" . number_format($totalkm) . "</b></td>";
            $tbl .= "<td align='right'><b>" . number_format($totaloil, 2) . "</b></td>";
            $tbl .= "<td align='right'><b>" . number_format($totaloil_money, 2) . "</b></td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='3' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

}
