<?php

/*
 * รายงาน Log
 */

class RptlogController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'report';

            if (!isset(Yii::app()->session['rptlog_start_date'])) {
                Yii::app()->session['rptlog_start_date'] = MyDate::dateToText(date('Y-m-d'));
                Yii::app()->session['rptlog_end_date'] = MyDate::dateToText(date('Y-m-d'));
            }
            Yii::app()->session['report_tab'] = 'tab3';
            return true;
        }
        return false;
    }

    //รายชื่อรถ
    public function actionIndex() {
        $start_date = Yii::app()->session['rptlog_start_date'];
        $end_date = Yii::app()->session['rptlog_end_date'];

        $this->render('//reportpage/rptlog', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionPreview() {
        Yii::app()->session['rptlog_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptlog_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $user = (isset($_POST['duallistbox_user'])) ? implode(",", $_POST['duallistbox_user']) : '';

        $criteria = new CDbCriteria;
        $criteria->condition = "(indate between '$start_date' AND '$end_date')";
        if ($user != '') {
            $criteria->condition .= " AND (user_id in($user))";
        }
        $criteria->order = "indate asc, intime asc, user_name asc, code asc";
        $models = Userlog::model()->findAll($criteria);

        $caption = "รายงานประวัติการใช้โปรแกรม";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'><strong>ระหว่างวันที่</strong> " . MyDate::dateThai($start_date) . " <strong>ถึง</strong> " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;">
          <thead>
          <tr>
          <th width='140'>วันที่</th>
          <th width='100'>ชื่อเข้าใช้งาน</th>
          <th>คำอธิบาย</th>
          <th width='120'>IP</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        foreach ($models as $r) {
            $irow++;
            $tbl .= "<tr>";
            $tbl .= "<td align='center' valign='top'>" . MyDate::dateToText($r->indate) . " " . $r->intime . "</td>";
            $tbl .= "<td align='center' valign='top'>$r->user_name</td>";

            $tbl .= "<td>$r->description</td>";
            $tbl .= "<td align='center' valign='top'>$r->ip</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $tbl .= "<tr><td colspan='5' align='center'><b>รวมทั้งหมด $irow รายการ</b></td></tr>";
        } else {
            $tbl .= "<tr><td colspan='5' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }

        $tbl .= "<tbody></table>";
        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

}
