<?php

/*
 * รายงานสรุปค่าใช้จ่ายใช้รถ
 */

class RptmoneyworkController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'report';

            if (!isset(Yii::app()->session['rptcarwork_start_date'])) {
                Yii::app()->session['rptcarwork_start_date'] = MyDate::dateToText(date('Y-m-d'));
                Yii::app()->session['rptcarwork_end_date'] = MyDate::dateToText(date('Y-m-d'));
            }
            Yii::app()->session['report_tab'] = 'tab2';
            return true;
        }
        return false;
    }

    //รายงานค่าใช้จ่ายใช้รถ
    public function actionIndex() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptmoneywork', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.booking, tb_carwork.booking_id, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.status, tb_depart.name as depart_name,";
        $sql .= " tb_carwork.start_km, tb_carwork.end_km, tb_carwork.amount_oil, tb_carwork.oil_rate,";
        $sql .= " tb_carwork.pay_outcome, tb_carwork.pay_income, tb_carwork.car_rate, tb_carwork.car_money";
        $sql .= " FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานค่าใช้จ่ายใช้รถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='80' rowspan='2'>เลขที่เอกสาร</th>
          <th width='70' rowspan='2'>ทะเบียน</th>
          <th width='90' rowspan='2'>วันที่ใช้รถ</th>
          <th rowspan='2'>ใช้งานรถเพื่อ</th>
          <th width='110' rowspan='2'>แผนก</th>
          <th colspan='3'>น้ำมัน</th>
          <th colspan='2'>ค่าเช่ารถ</th>
          <th width='50' rowspan='2'>จ่ายอื่นๆ</th>
          <th rowspan='2'>รวมจ่าย</th>
          <th width='50' rowspan='2'>รับอื่นๆ</th>
          <th rowspan='2' align='right'>รวมสุทธิ</th>
          </tr>
          <tr>
          <th width='35' align='right'>ลิตร</th>
          <th width='35' align='right'>ราคา</th>
          <th width='50' align='right'>สุทธิ</th>
          <th width='35' align='right'>อัตรา</th>
          <th align='right'>ค่าเช่า</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $sum_oil_money = 0;
        $sum_car_money = 0;
        $sum_outcome = 0;
        $sum_income = 0;

        $total_pay = 0; //สุทธิจ่าย
        $total = 0;     //สุทธิทั้งหมด

        foreach ($models as $r) {
            $oil_money = (float)$r['amount_oil'] * (float)$r['oil_rate'];
            $sum_oil_money += $oil_money;
            $sum_car_money += $r['car_money'];
            $sum_outcome += $r['pay_outcome'];
            $sum_income += $r['pay_income'];

            $right_pay = $oil_money + $r['car_money'] + $r['pay_outcome'];    //รวมจ่าย
            $right_total = $r['pay_income'] - $right_pay; //รวมรับ - จ่าย

            $total_pay += $right_pay; //sum ยอดจ่าย
            $total += $right_total;  //sum ยอดสุทธิ

            $color = ($right_total < 0 ) ? 'style="color:red"' : '';
            $irow++;

            $depart_name = ($r['depart_name'] == null) ? '<span style="color:#d3d3d3">แผนกนี้ถูกลบออกจากระบบ</span>' : $r['depart_name'];
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>";
            $tbl .= "<div>" . MyDate::dateThai($r['start_date'], true) . " " . date("H:i", strtotime($r['start_time'])) . "</div>";
            $tbl .= "<div>" . MyDate::dateThai($r['end_date'], true) . " " . date("H:i", strtotime($r['end_time'])) . "</div>";
            $tbl .= "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td>$depart_name</td>";
            $tbl .= "<td align='right'>" . number_format($r['amount_oil'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['oil_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($oil_money, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_outcome'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($right_pay, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_income'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($right_total, 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $color = ($total < 0 ) ? 'style="color:red"' : '';

            $tbl .= "<tr>";
            $tbl .= "<td colspan='5' align='right'><b>รวมทั้งหมด $irow รายการ</b></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($total_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($total, 2) . "</td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='15' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }
        $tbl .= "<tbody></table>";
        $tbl .= "<strong>หมายเหตุ: </strong>ค่าเช่ารถ <u>อัตรา</u> = อัตราค่าเช่า:นาที<br/><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";


        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานค่าใช้จ่ายใช้รถ-ตามหน่วยงาน
    public function actionFaculty() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptmoneywork_faculty', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionFacultyPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $faculty = (isset($_POST['duallistbox_faculty'])) ? implode(",", $_POST['duallistbox_faculty']) : '';
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.status, tb_depart.name as depart_name,";
        $sql .= " tb_carwork.amount_oil, tb_carwork.oil_rate,";
        $sql .= " tb_carwork.pay_outcome, tb_carwork.pay_income, tb_carwork.car_rate, tb_carwork.car_money,";
        $sql .= " tb_depart.faculty_id, tb_faculty.name as faculty_name FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";
        $sql .= " LEFT JOIN tb_faculty ON tb_depart.faculty_id = tb_faculty.id";
        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        if ($faculty != '') {
            $sql .= " AND (tb_depart.faculty_id in($faculty))";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_faculty.name asc, tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานค่าใช้จ่ายใช้รถ-ตามหน่วยงาน";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='80' rowspan='2'>เลขที่เอกสาร</th>
          <th width='70' rowspan='2'>ทะเบียน</th>
          <th width='90' rowspan='2'>วันที่ใช้รถ</th>
          <th rowspan='2'>ใช้งานรถเพื่อ</th>
          <th width='110' rowspan='2'>แผนก</th>
          <th colspan='3'>น้ำมัน</th>
          <th colspan='2'>ค่าเช่ารถ</th>
          <th rowspan='2'>จ่ายอื่นๆ</th>
          <th rowspan='2'>รวมจ่าย</th>
          <th rowspan='2'>รับอื่นๆ</th>
          <th rowspan='2' align='right'>รวมสุทธิ</th>
          </tr>
          <tr>
          <th width='35' align='right'>ลิตร</th>
          <th width='35' align='right'>ราคา</th>
          <th align='right'>สุทธิ</th>
          <th width='35' align='right'>อัตรา</th>
          <th align='right'>ค่าเช่า</th>
          </tr>
          </thead>
          <tbody>
EOD;

        $irow = 0;
        $irow_fac = 0;
        $faculty_id = '';

        $sum_oil_money = 0;
        $sum_car_money = 0;
        $sum_outcome = 0;
        $sum_income = 0;
        $sum_pay = 0;
        $sum_total = 0;

        $totalsum_oil_money = 0;
        $totalsum_car_money = 0;
        $totalsum_outcome = 0;
        $totalsum_income = 0;
        $totalsum_pay = 0;
        $totalsum_total = 0;

        foreach ($models as $r) {
            if ($faculty_id != $r['faculty_id']) {
                if ($irow_fac > 0) {
                    $color = ($sum_total < 0 ) ? 'style="color:red"' : '';
                    $tbl .= "<tr>";
                    $tbl .= "<td colspan='5' align='right'><b>รวม $irow_fac รายการ</b></td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
                    $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
                    $tbl .= "</tr>";

                    $irow_fac = 0;
                    $sum_oil_money = 0;
                    $sum_car_money = 0;
                    $sum_outcome = 0;
                    $sum_income = 0;
                    $sum_pay = 0;
                    $sum_total = 0;
                }
                $tbl .= "<tr>";
                $tbl .= "<td colspan='14'><br/><strong>หน่วยงาน: " . $r['faculty_name'] . "<strong></td>";
                $tbl .= "</tr>";
            }

            $irow_fac++;
            $faculty_id = $r['faculty_id'];

            $oil_money = (float)$r['amount_oil'] * (float)$r['oil_rate'];
            $sum_oil_money += $oil_money;
            $sum_car_money += $r['car_money'];
            $sum_outcome += $r['pay_outcome'];
            $sum_income += $r['pay_income'];

            $right_pay = $oil_money + $r['car_money'] + $r['pay_outcome'];
            $right_total = $r['pay_income'] - $right_pay;
            $sum_pay += $right_pay;
            $sum_total += $right_total;

            $color = ($right_total < 0 ) ? 'style="color:red"' : '';
            $irow++;

            $depart_name = ($r['depart_name'] == null) ? '<span style="color:#d3d3d3">แผนกนี้ถูกลบออกจากระบบ</span>' : $r['depart_name'];
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>";
            $tbl .= "<div>" . MyDate::dateThai($r['start_date'], true) . " " . date("H:i", strtotime($r['start_time'])) . "</div>";
            $tbl .= "<div>" . MyDate::dateThai($r['end_date'], true) . " " . date("H:i", strtotime($r['end_time'])) . "</div>";
            $tbl .= "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td>$depart_name</td>";
            $tbl .= "<td align='right'>" . number_format($r['amount_oil'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['oil_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($oil_money, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_outcome'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($right_pay, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_income'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($right_total, 2) . "</td>";
            $tbl .= "</tr>";

            $totalsum_oil_money += $oil_money;
            $totalsum_car_money += $r['car_money'];
            $totalsum_outcome += $r['pay_outcome'];
            $totalsum_income += $r['pay_income'];
            $totalsum_pay += $right_pay;
            $totalsum_total += $right_total;
        }

        if ($irow_fac > 0) {
            $color = ($sum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td colspan='5' align='right'><b>รวม $irow_fac รายการ</b></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $color = ($totalsum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td colspan='5' align='right'><b>รวมทั้งหมด $irow รายการ</b></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_oil_money, 2) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($totalsum_total, 2) . "</td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='14' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }
        $tbl .= "<tbody></table>";
        $tbl .= "<strong>หมายเหตุ: </strong>ค่าเช่ารถ <u>อัตรา</u> = อัตราค่าเช่า:นาที<br/><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานค่าใช้จ่ายใช้รถ-ตามแผนก
    public function actionDepart() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptmoneywork_depart', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionDepartPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $depart = (isset($_POST['duallistbox_depart'])) ? implode(",", $_POST['duallistbox_depart']) : '';
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno, tb_carwork.booking, tb_carwork.booking_id, tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.depart_id, tb_depart.name as depart_name,";
        $sql .= " tb_carwork.start_km, tb_carwork.end_km, tb_carwork.amount_oil, tb_carwork.oil_rate,";
        $sql .= " tb_carwork.pay_outcome, tb_carwork.pay_income, tb_carwork.car_rate, tb_carwork.car_money";
        $sql .= " FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";
        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        if ($depart != '') {
            $sql .= " AND (tb_depart.id in($depart))";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_depart.name asc, tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานค่าใช้จ่ายใช้รถ-ตามแผนก";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='95' rowspan='2'>เลขที่เอกสาร</th>
          <th width='80' rowspan='2'>ทะเบียน</th>
          <th width='100' rowspan='2'>วันที่ใช้รถ</th>
          <th rowspan='2'>ใช้งานรถเพื่อ</th>
          <th colspan='3'>น้ำมัน</th>
          <th colspan='2'>ค่าเช่ารถ</th>
          <th rowspan='2'>จ่ายอื่นๆ</th>
          <th rowspan='2'>รวมจ่าย</th>
          <th rowspan='2'>รับอื่นๆ</th>
          <th rowspan='2' align='right'>รวมสุทธิ</th>
          </tr>
          <tr>
          <th width='40' align='right'>ลิตร</th>
          <th width='40' align='right'>ราคา</th>
          <th align='right'>สุทธิ</th>
          <th width='40' align='right'>อัตรา</th>
          <th align='right'>ค่าเช่า</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_depart = 0;
        $depart_id = '';

        $sum_oil_money = 0;
        $sum_car_money = 0;
        $sum_outcome = 0;
        $sum_income = 0;
        $sum_pay = 0;
        $sum_total = 0;

        $totalsum_oil_money = 0;
        $totalsum_car_money = 0;
        $totalsum_outcome = 0;
        $totalsum_income = 0;
        $totalsum_pay = 0;
        $totalsum_total = 0;
        foreach ($models as $r) {
            if ($depart_id != $r['depart_id']) {
                if ($irow_depart > 0) {
                    $color = ($sum_total < 0 ) ? 'style="color:red"' : '';
                    $tbl .= "<tr>";
                    $tbl .= "<td colspan='4' align='right'><b>รวม $irow_depart รายการ</b></td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
                    $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
                    $tbl .= "</tr>";

                    $irow_depart = 0;
                    $sum_oil_money = 0;
                    $sum_car_money = 0;
                    $sum_outcome = 0;
                    $sum_income = 0;
                    $sum_pay = 0;
                    $sum_total = 0;
                }

                $depart_name = ($r['depart_name'] == null) ? '<span style="color:#d3d3d3">แผนกนี้ถูกลบออกจากระบบ</span>' : $r['depart_name'];
                $tbl .= "<tr>";
                $tbl .= "<td colspan='13'><br/><strong>แผนก: $depart_name<strong></td>";
                $tbl .= "</tr>";
            }

            $irow++;
            $irow_depart++;
            $depart_id = $r['depart_id'];

            $oil_money = (float)$r['amount_oil'] * (float)$r['oil_rate'];
            $sum_oil_money += $oil_money;
            $sum_car_money += $r['car_money'];
            $sum_outcome += $r['pay_outcome'];
            $sum_income += $r['pay_income'];

            $right_pay = $oil_money + $r['car_money'] + $r['pay_outcome'];
            $right_total = $r['pay_income'] - $right_pay;
            $sum_pay += $right_pay;
            $sum_total += $right_total;

            $color = ($right_total < 0 ) ? 'style="color:red"' : '';
            $irow++;
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>";
            $tbl .= "<div>" . MyDate::dateThai($r['start_date'], true) . " " . date("H:i", strtotime($r['start_time'])) . "</div>";
            $tbl .= "<div>" . MyDate::dateThai($r['end_date'], true) . " " . date("H:i", strtotime($r['end_time'])) . "</div>";
            $tbl .= "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['amount_oil'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['oil_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($oil_money, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_outcome'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($right_pay, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_income'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($right_total, 2) . "</td>";
            $tbl .= "</tr>";

            $totalsum_oil_money += $oil_money;
            $totalsum_car_money += $r['car_money'];
            $totalsum_outcome += $r['pay_outcome'];
            $totalsum_income += $r['pay_income'];
            $totalsum_pay += $right_pay;
            $totalsum_total += $right_total;
        }

        if ($irow_depart > 0) {
            $color = ($sum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td colspan='4' align='right'><b>รวม $irow_depart รายการ</b></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $color = ($totalsum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td colspan='4' align='right'><b>รวมทั้งหมด $irow รายการ</b></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_oil_money, 2) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($totalsum_total, 2) . "</td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='13' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }
        $tbl .= "<tbody></table>";
        $tbl .= "<strong>หมายเหตุ: </strong>ค่าเช่ารถ <u>อัตรา</u> = อัตราค่าเช่า:นาที<br/><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานค่าใช้จ่ายใช้รถ-ตามทะเบียนรถ
    public function actionTabian() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptmoneywork_tabian', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionTabianPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $tabian = (isset($_POST['duallistbox_tabian'])) ? implode(",", $_POST['duallistbox_tabian']) : '';

        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        $sql = "SELECT tb_carwork.id, tb_carwork.docno , tb_carwork.start_date, tb_carwork.start_time, ";
        $sql .= " tb_carwork.end_date, tb_carwork.end_time, tb_car.code as car_code , ";
        $sql .= " tb_carwork.working, tb_carwork.car_id, tb_depart.name as depart_name,";
        $sql .= " tb_carwork.amount_oil, tb_carwork.oil_rate,";
        $sql .= " tb_carwork.pay_outcome, tb_carwork.pay_income, tb_carwork.car_rate, tb_carwork.car_money";
        $sql .= " FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";
        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }
        if ($tabian != '') {
            $sql .= " AND (tb_carwork.car_id in($tabian))";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_depart.name asc, tb_carwork.start_date asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $caption = "รายงานค่าใช้จ่ายใช้รถ-ตามทะเบียนรถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'>ระหว่างวันที่ " . MyDate::dateThai($start_date) . " ถึง " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:8pt">
          <thead>
          <tr>
          <th width='95' rowspan='2'>เลขที่เอกสาร</th>
          <th width='100' rowspan='2'>วันที่ใช้รถ</th>
          <th rowspan='2'>ใช้งานรถเพื่อ</th>
          <th width='100' rowspan='2'>แผนก</th>
          <th colspan='3'>น้ำมัน</th>
          <th colspan='2'>ค่าเช่ารถ</th>
          <th rowspan='2'>จ่ายอื่นๆ</th>
          <th rowspan='2'>รวม</th>
          <th rowspan='2'>รับอื่นๆ</th>
          <th rowspan='2' align='right'>รวมสุทธิ</th>
          </tr>
          <tr>
          <th width='40' align='right'>ลิตร</th>
          <th width='40' align='right'>ราคา</th>
          <th align='right'>สุทธิ</th>
          <th width='40' align='right'>อัตรา</th>
          <th align='right'>ค่าเช่า</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_car = 0;
        $car_id = '';

        $sum_oil_money = 0;
        $sum_car_money = 0;
        $sum_outcome = 0;
        $sum_income = 0;
        $sum_pay = 0;
        $sum_total = 0;

        $totalsum_oil_money = 0;
        $totalsum_car_money = 0;
        $totalsum_outcome = 0;
        $totalsum_income = 0;
        $totalsum_pay = 0;
        $totalsum_total = 0;
        foreach ($models as $r) {
            if ($car_id != $r['car_id']) {
                if ($irow_car > 0) {
                    $color = ($sum_total < 0 ) ? 'style="color:red"' : '';

                    $tbl .= "<tr>";
                    $tbl .= "<td colspan='4' align='right'><b>รวม $irow_car รายการ</b></td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
                    $tbl .= "<td></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
                    $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
                    $tbl .= "</tr>";


                    $irow_car = 0;
                    $sum_oil_money = 0;
                    $sum_car_money = 0;
                    $sum_outcome = 0;
                    $sum_income = 0;
                    $sum_pay = 0;
                    $sum_total = 0;
                }
                $tbl .= "<tr>";
                $tbl .= "<td colspan='13'><br/><strong>ทะเบียน: " . $r['car_code'] . "<strong></td>";
                $tbl .= "</tr>";
            }

            $irow++;
            $irow_car++;
            $car_id = $r['car_id'];

            $oil_money = (float)$r['amount_oil'] * (float)$r['oil_rate'];
            $sum_oil_money += $oil_money;
            $sum_car_money += $r['car_money'];
            $sum_outcome += $r['pay_outcome'];
            $sum_income += $r['pay_income'];

            $right_pay = $oil_money + $r['car_money'] + $r['pay_outcome'];
            $right_total = $r['pay_income'] - $right_pay;
            $sum_pay += $right_pay;
            $sum_total += $right_total;

            $color = ($right_total < 0 ) ? 'style="color:red"' : '';
            $irow++;

            $depart_name = ($r['depart_name'] == null) ? '<span style="color:#d3d3d3">แผนกนี้ถูกลบออกจากระบบ</span>' : $r['depart_name'];
            $tbl .= "<tr>";
            $tbl .= "<td align='center' x:str>" . $r['docno'] . "</td>";
            $tbl .= "<td align='center'>";
            $tbl .= "<div>" . MyDate::dateThai($r['start_date'], true) . " " . date("H:i", strtotime($r['start_time'])) . "</div>";
            $tbl .= "<div>" . MyDate::dateThai($r['end_date'], true) . " " . date("H:i", strtotime($r['end_time'])) . "</div>";
            $tbl .= "</td>";
            $tbl .= "<td>" . $r['working'] . "</td>";
            $tbl .= "<td>$depart_name</td>";
            $tbl .= "<td align='right'>" . number_format($r['amount_oil'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['oil_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($oil_money, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_rate'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['car_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_outcome'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($right_pay, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['pay_income'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($right_total, 2) . "</td>";
            $tbl .= "</tr>";

            $totalsum_oil_money += $oil_money;
            $totalsum_car_money += $r['car_money'];
            $totalsum_outcome += $r['pay_outcome'];
            $totalsum_income += $r['pay_income'];
            $totalsum_pay += $right_pay;
            $totalsum_total += $right_total;
        }

        if ($irow_car > 0) {
            $color = ($sum_total < 0 ) ? 'style="color:red"' : '';

            $tbl .= "<tr>";
            $tbl .= "<td colspan='4' align='right'><b>รวม $irow_car รายการ</b></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $color = ($totalsum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td colspan='4' align='right'><b>รวมทั้งหมด $irow รายการ</b></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_oil_money, 2) . "</td>";
            $tbl .= "<td></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($totalsum_total, 2) . "</td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='13' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }
        $tbl .= "<tbody></table>";
        $tbl .= "<strong>หมายเหตุ: </strong>ค่าเช่ารถ <u>อัตรา</u> = อัตราค่าเช่า:นาที<br/><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4l", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF('A4-L');
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานสรุปค่าใช้จ่ายใช้รถ
    public function actionSummary() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptmoneywork_summary', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionSummaryPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        //สร้างตารางชั่วคราว
        $sql = "
            DROP TEMPORARY TABLE IF EXISTS tmp_summary;
            CREATE TEMPORARY TABLE IF NOT EXISTS `tmp_summary` (
                `faculty_id` INT NULL ,
                `depart_id` INT NULL ,
                `faculty_name` VARCHAR( 200 ) NULL ,
                `depart_name` VARCHAR( 200 ) NULL ,
                `count_row` INT NULL ,
                `count_day` float NULL ,
                `oil_money` float NULL ,
                `car_money` float NULL ,
                `pay_outcome` float NULL ,
                `pay_income` float NULL ,
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY
            ) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            ";
        Yii::app()->db->createCommand($sql)->execute();

        $sql = "SELECT tb_carwork.id,tb_carwork.start_date, tb_carwork.end_date,";
        $sql .= " tb_car.code as car_code, tb_carwork.person_name, tb_depart.name as depart_name, tb_carwork.depart_id,";
        $sql .= " tb_depart.faculty_id, tb_faculty.name as faculty_name,";
        $sql .= " tb_carwork.start_time, tb_carwork.end_time,tb_carwork.start_km, tb_carwork.end_km, ";
        $sql .= " tb_carwork.pay_outcome, tb_carwork.pay_income, tb_carwork.car_rate, tb_carwork.car_money,";
        $sql .= " tb_carwork.amount_oil, tb_carwork.oil_rate FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";
        $sql .= " LEFT JOIN tb_depart ON tb_carwork.depart_id = tb_depart.id";
        $sql .= " LEFT JOIN tb_faculty ON tb_depart.faculty_id = tb_faculty.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_depart.name asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        foreach ($models as $r) {
            $ts1 = strtotime($r['start_date'] . " " . $r['start_time']);
            $ts2 = strtotime($r['end_date'] . " " . $r['end_time']);
            $seconds_diff = $ts2 - $ts1;
            $count_day = ($seconds_diff / 3600 / 24);

            $amount_oil = (float) $r['amount_oil'];
            $oil_rate = (float) $r['oil_rate'];
            
            $oil_money = $amount_oil * $oil_rate;

            $faculty_id = ($r['faculty_id'] == null) ? 0 : $r['faculty_id'];
            $faculty_name = ($r['faculty_name'] == null) ? 'หน่วยงานนี้ถูกลบออกจากระบบ' : $r['faculty_name'];
            $depart_id = ( $r['depart_id'] == null) ? 0 : $r['depart_id'];
            $depart_name = ($r['depart_name'] == null) ? 'แผนกนี้ถูกลบออกจากระบบ' : $r['depart_name'];
            
            $pay_outcome = ($r['pay_outcome']==null) ? 0 : $r['pay_outcome'];
            $pay_income = ($r['pay_income']==null) ? 0 : $r['pay_income'];

            $sql = "insert into tmp_summary (faculty_id,depart_id,faculty_name,depart_name,count_row,count_day,oil_money,car_money,pay_outcome,pay_income) values ";
            $sql .= " ('" . $faculty_id . "','" . $depart_id . "','" . $faculty_name . "','" . $depart_name . "',";
            $sql .= " 1,$count_day,$oil_money,'" . $r['car_money'] . "','" . $pay_outcome . "','" . $pay_income . "')";
            Yii::app()->db->createCommand($sql)->execute();
        }

        $sql = "SELECT tmp_summary.faculty_id, 
	tmp_summary.depart_id, 
	tmp_summary.faculty_name, 
	tmp_summary.depart_name, 
	sum(tmp_summary.count_row) AS sumrow, 
	sum(tmp_summary.count_day) AS sumday,
        sum(tmp_summary.oil_money) AS sumoil_money,
        sum(tmp_summary.car_money) AS sumcar_money,
        sum(tmp_summary.pay_outcome) AS sumpay_outcome,
        sum(tmp_summary.pay_income) AS sumpay_income
FROM tmp_summary
GROUP BY faculty_id,depart_id,faculty_name,depart_name
ORDER BY tmp_summary.faculty_name ASC, tmp_summary.depart_name ASC";

        $models = Yii::app()->db->createCommand($sql)->queryAll();
        $caption = "รายงานสรุปค่าใช้จ่ายใช้รถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'><strong>ระหว่างวันที่</strong> " . MyDate::dateThai($start_date) . " <strong>ถึง</strong> " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:9pt">
          <thead>
          <tr>            
          <th rowspan='2'>แผนก</th>
          <th colspan='2'>จำนวนใช้รถ</th>
          <th colspan='3'>ค่าใช้จ่าย</th>
          <th width='80' rowspan='2'>รวมจ่าย</th>
          <th width='60' rowspan='2'>รับอื่นๆ</th>
          <th width='80' rowspan='2'>รวมสุทธิ</th>
          </tr>
          <tr>            
          <th width='50'>ครั้ง</th>
          <th width='60'>วัน</th>
          <th width='70'>น้ำมัน</th>
          <th width='70'>ค่าเช่า</th>
          <th width='60'>จ่ายอื่นๆ</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $irow_fac = 0;
        $faculty_id = '';
        $sumrow = 0;
        $sumday = 0;
        $totalrow = 0;
        $totalday = 0;

        $sum_oil_money = 0;
        $sum_car_money = 0;
        $sum_outcome = 0;
        $sum_income = 0;
        $sum_pay = 0;
        $sum_total = 0;

        $totalsum_oil_money = 0;
        $totalsum_car_money = 0;
        $totalsum_outcome = 0;
        $totalsum_income = 0;
        $totalsum_pay = 0;
        $totalsum_total = 0;
        foreach ($models as $r) {
            if ($faculty_id != $r['faculty_id']) {
                if ($irow_fac > 0) {
                    $color = ($sum_total < 0 ) ? 'style="color:red"' : '';
                    $tbl .= "<tr>";
                    $tbl .= "<td align='right'><b><i>รวม:</i></b></td>";
                    $tbl .= "<td align='center'><b>$sumrow</b></td>";
                    $tbl .= "<td align='center'><b>" . number_format($sumday, 2) . "</b></td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
                    $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
                    $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
                    $tbl .= "</tr>";
                    $irow_fac = 0;
                    $sumrow = 0;
                    $sumday = 0;

                    $sum_oil_money = 0;
                    $sum_car_money = 0;
                    $sum_outcome = 0;
                    $sum_income = 0;
                    $sum_pay = 0;
                    $sum_total = 0;
                }
                $tbl .= "<tr>";
                $tbl .= "<td colspan='9'><br/><strong>หน่วยงาน: " . $r['faculty_name'] . "<strong></td>";
                $tbl .= "</tr>";
            }

            $faculty_id = $r['faculty_id'];
            $irow_fac++;
            $irow++;

            $sumrow += $r['sumrow'];
            $sumday += $r['sumday'];
            $totalrow += $r['sumrow'];
            $totalday += $r['sumday'];

            $sum_oil_money += $r['sumoil_money'];
            $sum_car_money += $r['sumcar_money'];
            $sum_outcome += $r['sumpay_outcome'];
            $sum_income += $r['sumpay_income'];

            $right_pay = $r['sumoil_money'] + $r['sumcar_money'] + $r['sumpay_outcome'];
            $right_total = $r['sumpay_income'] - $right_pay;
            $sum_pay += $right_pay;
            $sum_total += $right_total;

            $color = ($right_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td>" . $r['depart_name'] . "</td>";
            $tbl .= "<td align='center'>" . $r['sumrow'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['sumday'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumoil_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumcar_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumpay_outcome'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($right_pay, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumpay_income'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($right_total, 2) . "</td>";
            $tbl .= "</tr>";

            $totalsum_oil_money += $r['sumoil_money'];
            $totalsum_car_money += $r['sumcar_money'];
            $totalsum_outcome += $r['sumpay_outcome'];
            $totalsum_income += $r['sumpay_income'];
            $totalsum_pay += $right_pay;
            $totalsum_total += $right_total;
        }

        if ($irow_fac > 0) {
            $color = ($sum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td align='right'><b><i>รวม:</i></b></td>";
            $tbl .= "<td align='center'><b>$sumrow</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($sumday, 2) . "</b></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $color = ($totalsum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td align='right'><b>รวมทั้งหมด:</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalrow) . "</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($totalday, 2) . "</b></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_oil_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($totalsum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($totalsum_total, 2) . "</td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='8' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

    //รายงานสรุปค่าใช้จ่ายใช้รถ-ตามทะเบียนรถ
    public function actionTabianSummary() {
        $start_date = Yii::app()->session['rptcarwork_start_date'];
        $end_date = Yii::app()->session['rptcarwork_end_date'];

        $this->render('//reportpage/rptmoneywork_tabian_summary', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionTabianSummaryPreview() {
        Yii::app()->session['rptcarwork_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptcarwork_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);
        $status = $_POST['status'];
        switch ($status) {
            case '99':
                $status_text = 'ทุกสถานะ';
                break;
            case '0':
                $status_text = 'อยู่ระหว่างใช้งาน';
                break;
            case '1':
                $status_text = 'เสร็จงาน/คืนรถ';
                break;
        }

        //สร้างตารางชั่วคราว
        $sql = "
            DROP TEMPORARY TABLE IF EXISTS tmp_summary;
            CREATE TEMPORARY TABLE IF NOT EXISTS `tmp_summary` (
                `car_code` VARCHAR( 20 ) NULL ,
                `count_row` INT NULL ,
                `count_day` float NULL ,
                `oil_money` float NULL ,
                `car_money` float NULL ,
                `pay_outcome` float NULL ,
                `pay_income` float NULL ,
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY
            ) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            ";
        Yii::app()->db->createCommand($sql)->execute();

        $sql = "SELECT tb_carwork.id,tb_carwork.start_date, tb_carwork.end_date,";
        $sql .= " tb_car.code as car_code, tb_carwork.start_time, tb_carwork.end_time,";
        $sql .= " tb_carwork.start_km, tb_carwork.end_km, tb_carwork.pay_outcome, tb_carwork.pay_income, ";
        $sql .= " tb_carwork.car_rate, tb_carwork.car_money,";
        $sql .= " tb_carwork.amount_oil, tb_carwork.oil_rate FROM tb_carwork ";
        $sql .= " LEFT JOIN tb_car ON tb_carwork.car_id = tb_car.id";

        if ($status == '99') {
            $sql .= " Where (tb_carwork.status<>'99') ";
        } else {
            $sql .= " Where (tb_carwork.status='$status') ";
        }

        $sql .= " AND (";
        $sql .= " (date(tb_carwork.start_date) between '$start_date' AND '$end_date')";
        $sql .= " OR (date(tb_carwork.end_date) between '$start_date' AND '$end_date')";
        $sql .= " OR ('$start_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= " OR ('$end_date' between date(tb_carwork.start_date) AND date(tb_carwork.end_date))";
        $sql .= ")";

        $sql .= " Order by tb_car.code asc";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        foreach ($models as $r) {
            $ts1 = strtotime($r['start_date'] . " " . $r['start_time']);
            $ts2 = strtotime($r['end_date'] . " " . $r['end_time']);
            $seconds_diff = $ts2 - $ts1;
            $count_day = ($seconds_diff / 3600 / 24);

            $amount_oil = (float) $r['amount_oil'];
            $oil_rate = (float) $r['oil_rate'];
            $oil_money = $amount_oil * $oil_rate;
            
            $pay_outcome = ($r['pay_outcome']==null) ? 0 : $r['pay_outcome'];
            $pay_income = ($r['pay_income']==null) ? 0 : $r['pay_income'];

            $sql = "insert into tmp_summary (car_code,count_row,count_day,oil_money,car_money,pay_outcome,pay_income) values ";
            $sql .= " ('" . $r['car_code'] . "', 1,$count_day,$oil_money,'" . $r['car_money'] . "','" . $pay_outcome . "','" . $pay_income . "')";
            Yii::app()->db->createCommand($sql)->execute();
        }

        $sql = "SELECT tmp_summary.car_code, 
	sum(tmp_summary.count_row) AS sumrow, 
	sum(tmp_summary.count_day) AS sumday,
        sum(tmp_summary.oil_money) AS sumoil_money,
        sum(tmp_summary.car_money) AS sumcar_money,
        sum(tmp_summary.pay_outcome) AS sumpay_outcome,
        sum(tmp_summary.pay_income) AS sumpay_income
FROM tmp_summary
GROUP BY car_code
ORDER BY tmp_summary.car_code ASC";

        $models = Yii::app()->db->createCommand($sql)->queryAll();
        $caption = "รายงานสรุปค่าใช้จ่ายใช้รถ-ตามทะเบียนรถ";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl .= "<div class='caption2'><strong>ระหว่างวันที่</strong> " . MyDate::dateThai($start_date) . " <strong>ถึง</strong> " . MyDate::dateThai($end_date) . "</div>";
        $tbl .= "<div class='caption2'>สถานะงาน: $status_text</div>";
        $tbl .= <<<EOD
          <table style="overflow:wrap;font-size:9pt">
          <thead>
          <tr>            
          <th rowspan='2'>ทะเบียนรถ</th>
          <th colspan='2'>จำนวนใช้รถ</th>
          <th colspan='3'>ค่าใช้จ่าย</th>
          <th width='80' rowspan='2'>รวมจ่าย</th>
          <th width='60' rowspan='2'>รับอื่นๆ</th>
          <th width='80' rowspan='2'>รวมสุทธิ</th>
          </tr>
          <tr>            
          <th width='50'>ครั้ง</th>
          <th width='60'>วัน</th>
          <th width='70'>น้ำมัน</th>
          <th width='70'>ค่าเช่า</th>
          <th width='60'>จ่ายอื่นๆ</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $sumrow = 0;
        $sumday = 0;
        $totalrow = 0;
        $totalday = 0;

        $sum_oil_money = 0;
        $sum_car_money = 0;
        $sum_outcome = 0;
        $sum_income = 0;
        $sum_pay = 0;
        $sum_total = 0;
        foreach ($models as $r) {
            $irow++;

            $sumrow += $r['sumrow'];
            $sumday += $r['sumday'];
            $totalrow += $r['sumrow'];
            $totalday += $r['sumday'];

            $sum_oil_money += $r['sumoil_money'];
            $sum_car_money += $r['sumcar_money'];
            $sum_outcome += $r['sumpay_outcome'];
            $sum_income += $r['sumpay_income'];

            $right_pay = $r['sumoil_money'] + $r['sumcar_money'] + $r['sumpay_outcome'];
            $right_total = $r['sumpay_income'] - $right_pay;
            $sum_pay += $right_pay;
            $sum_total += $right_total;

            $color = ($right_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td>" . $r['car_code'] . "</td>";
            $tbl .= "<td align='center'>" . $r['sumrow'] . "</td>";
            $tbl .= "<td align='center'>" . number_format($r['sumday'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumoil_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumcar_money'], 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumpay_outcome'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($right_pay, 2) . "</td>";
            $tbl .= "<td align='right'>" . number_format($r['sumpay_income'], 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($right_total, 2) . "</td>";
            $tbl .= "</tr>";
        }

        if ($irow > 0) {
            $color = ($sum_total < 0 ) ? 'style="color:red"' : '';
            $tbl .= "<tr>";
            $tbl .= "<td align='right'><b><i>รวม:</i></b></td>";
            $tbl .= "<td align='center'><b>$sumrow</b></td>";
            $tbl .= "<td align='center'><b>" . number_format($sumday, 2) . "</b></td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_oil_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_car_money, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_outcome, 0) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_pay, 2) . "</td>";
            $tbl .= "<td align='right' class='bold'>" . number_format($sum_income, 0) . "</td>";
            $tbl .= "<td align='right' class='bold' $color>" . number_format($sum_total, 2) . "</td>";
            $tbl .= "</tr>";
        } else {
            $tbl .= "<tr><td colspan='8' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }

        $tbl .= "<tbody></table><br/><br/>";
        $tbl .= "<table class='noborder'>";
        $tbl .= "<tr>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้บันทึก......................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "<td width='50%' align='center'>";
        $tbl .= "ผู้ตรวจสอบ...................................................................<br/><br/>";
        $tbl .= "ตำแหน่ง.....................................................................";
        $tbl .= "</td>";
        $tbl .= "</tr>";
        $tbl .= "</table>";

        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content .= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

}
