<?php

/**
 * This is the model class for table "tb_carfile".
 *
 * The followings are the available columns in table 'tb_carfile':
 * @property integer $id
 * @property integer $car_id
 * @property string $oldfilename
 * @property string $filename
 * @property string $path
 * @property string $comment
 */
class Carfile extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'tb_carfile';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('car_id', 'numerical', 'integerOnly' => true),
            array('oldfilename, comment', 'length', 'max' => 255),
            array('filename', 'length', 'max' => 50),
            array('path', 'safe'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, car_id, oldfilename, filename, path, comment', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => 'ID',
            'car_id' => 'Car',
            'oldfilename' => 'Oldfilename',
            'filename' => 'Filename',
            'path' => 'Path',
            'comment' => 'Comment',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('car_id', $this->car_id);
        $criteria->compare('oldfilename', $this->oldfilename, true);
        $criteria->compare('filename', $this->filename, true);
        $criteria->compare('path', $this->path, true);
        $criteria->compare('comment', $this->comment, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return Carfile the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    //สร้าง Folder ตาม id รถ
    function createDir($car_id) {
        $folder = "fileupload/car/";
        $upload_dir = Yii::getPathOfAlias("webroot") . '/' . $folder;

        /*
        if (!file_exists($upload_dir)) {
            mkdir($upload_dir, 0777, true);
            chmod($upload_dir, 0777);
        }
         * 
         */

        $data['folder'] = $folder;
        $data['upload_dir'] = $upload_dir;
        return $data;
    }

}
