<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/chosen/chosen.jquery.min.js');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap-inputmask.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' รายละเอียดการจอง';

$this->breadcrumbs = array(
    'งานรออนุมัติ' => array('/approve'),
    "รายละเอียดการจอง"
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';
?>

<style>
    .div-image-center{
        background-color: #FFF;
        width: 200px;
        height: 150px;
        line-height: 150px;
        text-align: center;
    }
    .dl-horizontal dt{
        padding-bottom: 10px;
    }
</style>

<?php if (Yii::app()->user->hasFlash('success')): ?>
    <script type="text/javascript">
        $(function () {
            $.facebox("<?php echo Yii::app()->user->getFlash('success'); ?>");
        });
    </script>
<?php endif; ?>

<div class="row" id='headRow' style='margin-bottom:5px;'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat" style='margin-bottom:5px'>
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดการจอง</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $carRow = Car::model()->getCarDetail($model->car_id);
                $carDetail = $carRow['code'] . ", " . $carRow['cartype_name'] . ", " . $carRow['brand_name'] . ", " . $carRow['oil_name'];

                $imagePath = Car::model()->getImagePath($model->car_id, "picture1");
                ?>
                <div class="row" style="margin-bottom:0px">
                    <div class="col-sm-3">
                        <div class="thumbnail">
                            <img src="<?php echo $imagePath; ?>" class="img-responsive">
                        </div>
                    </div>
                    <div class="col-sm-9">
                        <table class="no-border no-strip skills">
                            <tbody class="no-border-x no-border-y">
                                <tr valign='top'>
                                    <td>
                                        <h3 class="name" style="margin-top: 5px"><?php echo $carRow['code']; ?></h3>
                                        <p style="font-size:14px"><?php echo $carRow['cartype_name'] . ", " . $carRow['brand_name'] . ", " . $carRow['oil_name']; ?></p>
                                        <p style="font-size:13px">
                                            <strong>วันที่ใช้รถ </strong> <?php echo MyDate::dateThaiShort($model->start_date) . " เวลา " . date("H:i", strtotime($model->start_date)); ?>
                                            <strong>&nbsp;&nbsp;ถึงวันที่&nbsp;&nbsp;</strong> <?php echo MyDate::dateThaiShort($model->end_date) . " เวลา " . date("H:i", strtotime($model->end_date)); ?>
                                        </p>
                                    </td>
                                    <td class="nowrap" style="text-align:right">
                                        <?php
                                        echo Booking::model()->getLabelStatus($model->id);
                                        if ($model->status == '1') {
                                            echo "<p><i class='label label-default'>" . MyDate::dateToText($model->read_date, true) . "</i></p>";
                                        } else if ($model->status > 1) {
                                            echo "<p><i class='label label-default'>" . MyDate::dateToText($model->approve_date, true) . "</i></p>";
                                        }
                                        ?>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
                <hr style="margin-top:0px"/>

                <?php
                $address = $model->address;
                $address .= (strlen($model->tumbol) > 0) ? "&nbsp;&nbsp;&nbsp;ตำบล $model->tumbol" : '';
                $address .= (strlen($model->aumphur) > 0) ? "&nbsp;&nbsp;&nbsp;อำเภอ $model->aumphur" : '';
                $address .= (strlen($model->province) > 0) ? "&nbsp;&nbsp;&nbsp;จังหวัด $model->province" : '';
                ?>
                <dl class="dl-horizontal">
                    <dt>เลขที่ใบจอง</dt>
                    <dd><?php echo $model->docno; ?><span style="padding-left:20px"><strong>วันที่เวลา</strong></span><span style="padding-left:10px"><?php echo MyDate::dateThaiShort($model->docdate) . " " . $model->doctime; ?></span></dd>

                    <dt>จองใช้รถเพื่อ</dt>
                    <dd><?php echo $model->working; ?></dd>

                    <dt>สถานที่ไป</dt>
                    <dd><?php echo $address; ?></dd>

                    <dt>ใช้สำหรับแผนก</dt>
                    <dd>
                        <?php
                        $depart = Depart::model()->findByPk($model->depart_id);
                        if ($depart !== null) {
                            $depart->name;
                        }
                        ?>
                    </dd>

                    <dt>จำนวนผู้โดยสาร</dt>
                    <dd><?php echo $model->passenger_amount; ?></dd>

                    <dt>รายชื่อผู้โดยสาร</dt>
                    <dd><?php echo nl2br($model->passenger_name); ?></dd>

                    <dt>เอกสารอ้างอิง</dt>
                    <dd><?php echo $model->docref; ?></dd>

                    <dt>พนักงานขับรถ</dt>
                    <dd>
                        <?php
                        $driver = Driver::model()->findByPk($model->driver_id);
                        if ($driver !== null) {
                            echo $driver->title . $driver->firstname . " " . $driver->surname;
                        }
                        ?>
                    </dd>

                    <dt>ผู้ขอใช้</dt>
                    <dd><?php echo $model->person_name; ?></dd>

                    <dt>โทรศัพท์ติดต่อ</dt>
                    <dd><?php echo $model->tel; ?></dd>

                    <dt>อัตราค่าเช่า</dt>
                    <dd><?php echo number_format($model->car_rate, 2); ?> <strong>บาท:นาที &nbsp;&nbsp;&nbsp;&nbsp;ค่าเช่าสุทธิ&nbsp;&nbsp;&nbsp;</strong><?php echo number_format($model->car_money, 2); ?>&nbsp;&nbsp;<strong>บาท</strong></dd>

                    <dt>เพิ่มเติม</dt>
                    <dd><?php echo nl2br($model->comment); ?></dd>
                </dl>

                <hr/>
                <h4>ไฟล์แนบ</h4>
                <?php
                $baseUrl = Yii::app()->request->baseUrl;
                $irowFile = 0;
                $ret = '<ol>';
                for ($i = 1; $i < 3; $i++) {
                    $fieldName = "file$i" . "_name";
                    $fileRealName = "file$i";
                    if (Booking::model()->getFileExist($model->id, "file$i")) {
                        $irowFile++;
                        $ret .= "<li><a href='$baseUrl/fileupload/booking/" . $model->$fileRealName . "' target='_blank'>" . $model->$fieldName . "</a></li>";
                    }
                }
                $ret .= "</ol>";
                if ($irowFile > 0) {
                    echo $ret;
                } else {
                    echo "<div class='text-muted'><i>=== ไม่มีไฟล์แนบ ===</i></div>";
                }
                ?>

            </div>  <!-- end content -->

        </div>  <!-- end block flat -->
    </div>  <!-- end col -->
</div>  <!-- end row -->

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-pencil"></i></span>
                <h2>ผลการอนุมัติ</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $form = $this->beginWidget('CActiveForm', array(
                    'id' => 'myform',
                    'enableClientValidation' => false,
                    'enableAjaxValidation' => false,
                    'htmlOptions' => array(
                        'class' => 'form-horizontal',
                    ),
                    'action' => Yii::app()->createUrl('approve/update'), //<- your form action here
                ));
                ?>

                <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">การอนุมัติ</label>
                    <div class="<?php echo $classDiv; ?>">
                        <select id='booking_status' name='Booking[status]' class='form-control'>
                            <option value='0' <?php echo($model->status == '0') ? 'selected' : ''; ?>>รออนุมัติ</option>
                            <option value='1' <?php echo($model->status == '1') ? 'selected' : ''; ?>>อ่านแล้ว</option>
                            <option value='2' <?php echo($model->status == '2') ? 'selected' : ''; ?>>อนุมัติ</option>
                            <option value='3' <?php echo($model->status == '3') ? 'selected' : ''; ?>>ไม่อนุมัติ</option>
                            <option value='4' <?php echo($model->status == '4') ? 'selected' : ''; ?>>ยกเลิก</option>
                            <option value='5' <?php echo($model->status == '5') ? 'selected' : ''; ?>>ส่งคืนรถแล้ว</option>
                            <option value='6' <?php echo($model->status == '6') ? 'selected' : ''; ?>>รับคืนรถแล้ว</option>
                        </select>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">วันเวลาอนุมัติ</label>
                    <div class="<?php echo $classDiv; ?>">
                        <input type="text" value='<?php echo MyDate::dateToText($model->read_date, true); ?>' class='form-control' readonly="" tabindex="-1"/>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">พนักงานขับรถ</label>
                    <div class="<?php echo $classDiv; ?>">
                        <select name="Booking[driver_id]" data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control">
                            <option value=""></option>
                            <?php
                            $drivers = Driver::model()->findAll(array('condition' => 'status = 0', 'order' => 'firstname asc'));
                            foreach ($drivers as $r) {
                                $selected = ($model->driver_id == $r->id) ? 'selected' : '';
                                echo "<option value='$r->id' $selected>" . $r->title . $r->firstname . " " . $r->surname . "</option>";
                            }
                            ?>
                        </select>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">หมายเหตุ</label>
                    <div class="col-sm-10">
                        <?php echo $form->textArea($model, 'approve_comment', array('rows' => 2, 'class' => 'form-control')); ?>
                    </div>
                </div>

            </div>  <!-- end content -->


            <?php //if ($model->status == '5' || $model->status == '6'): ?>
      <!--<div class='alert alert-info'><h4 style='margin:0px;text-align:center'>รายการจองนี้ได้ทำการ <strong><u><?php //echo Booking::model()->getStatusText($model->status);    ?></u></strong> ไม่สามารถแก้ไขการจองได้</h4></div>-->
            <?php //else: ?>

            <div class="form-actions form-actions-gt">
                <div class="row no-margin">
                    <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                        <i class="fa fa-save"></i>
                        บันทึกผลการอนุมัติ
                    </button>
                </div>
            </div>

            <?php //endif; ?>

            <?php $this->endWidget(); ?>

        </div>  <!-- end block flat -->
    </div>  <!-- end col -->
</div>  <!-- end row -->

<script type='text/javascript'>
    $(document).ready(function () {
        $(".chzn-select-deselect").chosen({
            allow_single_deselect: true,
            no_results_text: 'ไม่พบรายชื่อ!',
            search_contains: true
        });
    });

    function save() {
        $('#myform').submit();
    }
</script>