<form id='formUploadFile' action="<?php echo Yii::app()->createUrl('car/ajaxUpload'); ?>" 
      onSubmit="return false" 
      method="post" enctype="multipart/form-data" 
      id="MyUploadForm"
      class='form-horizontal'>

    <input type='hidden' id='car_id' name='car_id' value='<?php echo $car_id; ?>'/>
    <div class="form-group">
        <label class="col-md-2 control-label">เลือกไฟล์</label>
        <div class="col-md-10">
            <input type="file" id='file_upload' name="file_upload"/>
        </div>
    </div>

    <div class="form-group">
        <label class="col-md-2 control-label">คำอธิบาย</label>
        <div class="col-md-6">
            <input type="text" id='comment' name="comment" maxlength="100" class='form-control'/>
        </div>
    </div>

    <div class="form-group">
        <label class="col-md-2 control-label"></label>
        <div class="col-md-10">
            <button type="submit" id="submit-btn" class="btn btn-primary"><i class='fa fa-upload'></i> อัพโหลด</button>
        </div>
    </div>
</form>
<div class="clearfix"></div>

<div id='divGridCarFile'></div>

<script type="text/javascript">
    $(function () {
        // Variable to store your files
        var files;

        // Add events
        $('input[type=file]').on('change', prepareUpload);
        $('#formUploadFile').on('submit', uploadFiles);

        // Grab the files and set them to our variable
        function prepareUpload(event) {
            files = event.target.files;
        }

        // Catch the form submit and upload the files
        function uploadFiles(event) {
            if (!$('#file_upload').val()) {
                bootbox.alert(artalert('danger', 'คุณต้องเลือกไฟล์ที่ต้องการอัพโหลดก่อน !!'));
                return false;
            }

            event.stopPropagation(); // Stop stuff happening
            event.preventDefault(); // Totally stop stuff happening

            // START A LOADING SPINNER HERE

            // Create a formdata object and add the files
            var data = new FormData();
            $.each(files, function (key, value) {
                data.append(key, value);
            });

            data.append('car_id', $('#car_id').val());
            data.append('comment', $('#comment').val());
            $.ajax({
                url: '<?php echo Yii::app()->createUrl('carfile/ajaxUpload'); ?>&files',
                type: 'POST',
                data: data,
                cache: false,
                dataType: 'json',
                processData: false, // Don't process the files
                contentType: false, // Set content type to false as jQuery will tell the server its a query string request
                success: function (data, textStatus, jqXHR) {
                    if (typeof data.error === 'undefined')
                    {
                        // Success so call function to process the form
                        submitForm(event, data);
                    } else {
                        // Handle errors here
                        bootbox.alert(artalert('danger', 'ERRORS: ' + data.error));
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    // Handle errors here
                    bootbox.alert(artalert('danger', 'ERRORS: ' + textStatus));
                    // STOP LOADING SPINNER
                }
            });
        }

        function submitForm(event, data) {
            // Create a jQuery object from the form
            $form = $(event.target);

            // Serialize the form data
            var formData = $form.serialize();

            // You should sterilise the file names
            $.each(data.files, function (key, value) {
                formData = formData + '&filenames[]=' + value;
            });

            $.ajax({
                url: '<?php echo Yii::app()->createUrl('carfile/ajaxUpload'); ?>',
                type: 'POST',
                data: formData,
                cache: false,
                dataType: 'json',
                success: function (data, textStatus, jqXHR) {
                    if (typeof data.error === 'undefined') {
                        // Success so call function to process the form
                        bootbox.alert('อัพโหลดไฟล์สำเร็จ');
                        $('#file_upload').val('');
                        $('#comment').val('');
                        loadDivGridCarFile();
                    } else {
                        // Handle errors here
                        bootbox.alert(artalert('danger', 'ERRORS: ' + data.error));
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    // Handle errors here
                    bootbox.alert(artalert('danger', 'ERRORS: ' + textStatus));
                },
                complete: function () {
                    // STOP LOADING SPINNER
                }
            });
        }

        loadDivGridCarFile();
    });

    function loadDivGridCarFile(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('carfile/ajaxList') ?>";
        var p = {};
        p['car_id'] = $('#id').val();

        $('#divGridCarFile').load(url, p);
        return true;
    }

    function delCarFile(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบไฟล์นี้ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('carfile/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function (data) {
                        if (data.msgText != '') {
                            bootbox.alert(data.msgText);
                        } else {
                            loadDivGridCarFile();
                        }
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ERRORS: ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง'));
                    }
                });
            }
        });
    }

    function delCarFile_(id) {
        BootstrapDialog.show({
            type: BootstrapDialog.TYPE_WARNING,
            title: 'ลบข้อมูล',
            message: 'คุณต้องการลบไฟล์นี้ใช่หรือไม่',
            buttons: [{
                    label: 'ไม่',
                    cssClass: 'btn-default',
                    action: function (dialog) {
                        dialog.close();
                    }
                }, {
                    label: 'ใช่,ลบทันที',
                    cssClass: 'btn-danger',
                    action: function (dialog) {
                        dialog.close();

                        var p = {};
                        p['id'] = id;
                        $.ajax({
                            data: p,
                            url: "<?php echo Yii::app()->createUrl('carfile/ajaxDelete') ?>",
                            type: 'POST',
                            dataType: 'json',
                            success: function (data) {
                                if (data.msgText != '') {
                                    wrapDialog(data.msgText);
                                    bootbox.alert(data.msgText);
                                } else {
                                    loadDivGridCarFile();
                                }
                            },
                            error: function () {
                                bootbox.alert(artalert('danger', 'ERRORS: ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง'));
                            }
                        });
                    }
                }]
        });

        return true;
    }
</script>

