<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/chosen/chosen.jquery.min.js');

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jquery.numeric.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' รายละเอียดซ่อมบำรุง';

$newORedit = ($model->id == '') ? 'เพิ่ม' : 'แก้ไข';
$this->breadcrumbs = array(
    'รายการซ่อมบำรุง' => array('/carfix'),
    "รายละเอียดซ่อมบำรุง ($newORedit)"
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';

$this->renderPartial('//layouts/hasFlash');
?>

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <?php
        $form = $this->beginWidget('CActiveForm', array(
            'id' => 'myform',
            'enableClientValidation' => false,
            'enableAjaxValidation' => false,
            'htmlOptions' => array(
                'class' => 'form-horizontal',
                'enctype' => 'multipart/form-data',
            ),
            'action' => Yii::app()->createUrl('carfix/update'), //<- your form action here
        ));
        ?>

        <div class="block-flat" style='margin-bottom: 10px'>
            <header>
                <span class="widget-icon"> <i class="fa fa-pencil-square-o"></i></span>
                <h2>รายละเอียดการซ่อม</h2>	
                <div class="widget-toolbar">
                    <?php
                    echo CHtml::link('<i class="fa fa-plus"></i> เพิ่มข้อมูล', array('carfix/create'), array('class' => 'btn btn-xs btn-success'));
                    echo '<a href="#" onclick="return del(\'' . $model->id . '\')" class="btn btn-xs btn-danger"><i class="fa fa-trash-o"></i> ลบข้อมูล</a>';
                    ?>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

                <div id='divBooking'>
                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">เลขที่เอกสาร<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'docno', array('class' => 'form-control', 'autofocus' => 'true', 'required' => 'true')); ?>
                                <span class="input-group-btn">
                                    <button type="button" class="btn btn-default" onclick="docrun()"><i class="fa fa-flash"></i></button>
                                </span>
                            </div>

                        </div>

                        <label class="<?php echo $classLabel; ?>">เอกสารอ้างอิง</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'docref', array('class' => 'form-control')); ?>
                        </div>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">ทะเบียนรถ<span class="required">*</span></label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php
                        echo $form->hiddenField($model, 'car_id');
                        $car = Car::model()->findByPk($model->car_id);

                        $carCode = '';
                        if ($car !== null) {
                            $carCode = $car->code;
                        }
                        ?>
                        <div class="input-group">
                            <input type='text' id='car_code' value='<?php echo $carCode; ?>' required="true" readonly="" class='form-control'>
                            <span class="input-group-btn">
                                <button type="button" class="btn btn-default" onclick="carModal()"><i class="fa fa-truck"></i></button>
                            </span>
                        </div>
                    </div>

                    <label class="<?php echo $classLabel; ?>">อู่ซ่อมรถ<span class="required">*</span></label>
                    <div class="<?php echo $classDiv; ?>">
                        <select name="Carfix[garage_id]" id='Carfix_garage_id' data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control" required="" title='คุณต้องเลือกอู่ซ่อมรถ'>
                            <option value=""></option>
                            <?php
                            $garages = Garage::model()->findAll(array('order' => 'name asc'));
                            foreach ($garages as $r) {
                                $selected = ($model->garage_id == $r->id) ? 'selected' : '';
                                echo "<option value='$r->id' $selected>$r->name</option>";
                            }
                            ?>
                        </select>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">วันที่ส่งซ่อม<span class="required">*</span></label>
                    <div class="<?php echo $classDiv; ?>">
                        <div class="input-group date">
                            <?php
                            $model->datefix = MyDate::dateToText($model->datefix);
                            echo $form->textField($model, 'datefix', array('class' => 'form-control', 'readonly' => 'true'));
                            ?>
                            <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                        </div>
                    </div>

                    <label class="<?php echo $classLabel; ?>">คาดว่าเสร็จ<span class="required">*</span></label>
                    <div class="<?php echo $classDiv; ?>">
                        <div class="input-group date">
                            <?php
                            $model->dateprocess = MyDate::dateToText($model->dateprocess);
                            echo $form->textField($model, 'dateprocess', array('class' => 'form-control', 'readonly' => 'true'));
                            ?>
                            <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                        </div>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">ซ่อมเสร็จจริง</label>
                    <div class="<?php echo $classDiv; ?>">
                        <div class="input-group date">
                            <?php
                            $model->datecomplete = MyDate::dateToText($model->datecomplete);
                            echo $form->textField($model, 'datecomplete', array('class' => 'form-control', 'placeholder' => 'วว/ดด/ปี พ.ศ.'));
                            ?>
                            <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                        </div>
                    </div>

                    <label class="<?php echo $classLabel; ?>">เลขไมล์ส่งซ่อม</label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php echo $form->textField($model, 'km', array('class' => 'form-control numeric')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">ค่าใช้จ่ายแผนก</label>
                    <div class="<?php echo $classDiv; ?>">
                        <select name="Carfix[depart_id]" id='Carfix_depart_id' data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control">
                            <option value=""></option>
                            <?php
                            $departs = Depart::model()->findAll(array('order' => 'name asc'));
                            foreach ($departs as $r) {
                                $selected = ($model->depart_id == $r->id) ? 'selected' : '';
                                echo "<option value='$r->id' $selected>$r->name</option>";
                            }
                            ?>
                        </select>
                    </div>

                    <label class="<?php echo $classLabel; ?>">ผู้ส่งซ่อม</label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php echo $form->textField($model, 'person_name', array('class' => 'form-control')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">อาการ/หมายเหตุ</label>
                    <div class="col-sm-10">
                        <?php echo $form->textArea($model, 'comment', array('rows' => 2, 'class' => 'form-control')); ?>
                    </div>
                </div>

            </div>  <!-- end content -->
        </div>      <!-- end block_flat -->

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-gavel"></i></span>
                <h2>รายการซ่อม (อะไหล่, ค่าบริการ ฯลฯ)</h2>	
                <div class="widget-toolbar">
                    <a href="javascript:void(0);" onclick='createItem();' class="btn btn-xs btn-info"><i class="fa fa-plus"></i> เพิ่มรายการซ่อม</a>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div id='div_grid'></div>
            </div> <!-- end content -->

            <div class="form-actions form-actions-gt" style='margin-top:5px'>
                <div class="row no-margin">
                    <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                        <i class="fa fa-save"></i>
                        บันทึกข้อมูล
                    </button>
                </div>
            </div>
        </div>     <!-- end block_flat -->

        <?php $this->endWidget(); ?>
    </div>

</div>

<!-- Modal Car -->
<?php $this->renderPartial('//car/modalCar'); ?>

<!-- Modal -->
<div class="modal fade colored-header" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<script type='text/javascript'>
    $(document).ready(function () {
        $(".numeric").numeric({negative: false});

        $(".chzn-select-deselect").chosen({
            allow_single_deselect: true,
            no_results_text: 'ไม่พบรายชื่อ!',
            search_contains: true
        });

        $('#myform').validate({ignore: ":hidden:not(select)",
            invalidHandler: function (event, validator) {
                loadingStaticRemove();
            }
        });

        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            orientation: "top auto",
            format: "dd/mm/yyyy"
        });

        load_div_grid();

        $('.modal').on('shown.bs.modal', function () {
            $(this).find("[autofocus]:first").focus();
        });
    });

    function save() {
        var ret = '';
        if ($('#car_code').val() == '') {
            ret += 'คุณต้องเลือกรถที่ต้องการก่อน<br/>';
        }

        if ($('#Carfix_datefix').val() == '' || $('#Carfix_dateprocess').val() == '') {
            ret += 'คุณต้องเลือกวันที่ส่งซ่อม และวันที่คาดว่าเสร็จ<br/>';
        }

        if (ret != '') {
            bootbox.alert(artalert('warning', ret));
        } else {
            var p = {};
            p['save'] = true;

            p['id'] = $('#id').val();
            p['docno'] = $('#Carfix_docno').val();

            $.ajax({
                data: p,
                url: "<?php echo Yii::app()->createUrl('carfix/ajaxValidate') ?>",
                type: 'POST',
                dataType: 'json',
                success: function (data) {
                    scrollToTop();
                    if (data.msg == '0') {
                        loadingStatic();
                        $('#myform').submit();
                    } else {
                        bootbox.alert(artalert('danger', data.msgText));
                    }
                },
                error: function () {
                    bootbox.alert(artalert('danger', 'ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!'));
                }});
        }
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('carfix/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        window.location.href = "<?php echo Yii::app()->createUrl('carfix/create'); ?>"
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }

    //เปิด Modal Car
    function carModal() {
        loadGridCarModal();
        $('.modal').on('shown.bs.modal', function () {
            $('#txtsearchCarModal').focus();
        });
        $('#myModalCar').modal({show: true});
    }

    //เลือกหมวดจาก modal
    function carModalSelect(id, code) {
        $('#Carfix_car_id').val(id);
        $('#car_code').val(code);
        $('#myModalCar').modal('hide');
    }

    //รายการซ่อม อะไหล่
    function load_div_grid() {
        var url = "<?php echo Yii::app()->createUrl('carfix/ajaxListItem') ?>";
        var p = {};
        p['id'] = $('#id').val();
        $('#div_grid').load(url, p);
        return true;
    }

    function createItem() {
        $('#myModal').load("<?php echo Yii::app()->createUrl('carfix/ajaxCreateItem') ?>", function () {
            $('#myModal').modal('show');
        });
        return true;
    }

    function updateItem(id) {
        var p = {};
        p['idSub'] = id;
        p['carfix_id'] = $('#id').val();
        $('#myModal').load("<?php echo Yii::app()->createUrl('carfix/ajaxUpdateItem') ?>", p, function () {
            $('#myModal').modal('show');
        });
        return true;
    }

    function saveItem() {
        var p = {};
        p['save'] = true;
        p['carfix_id'] = $('#id').val();
        p['idSub'] = $('#idSub').val();
        p['item'] = $('#CarfixSub_item').val();
        p['qty'] = $('#CarfixSub_qty').val();
        p['unitname'] = $('#CarfixSub_unitname').val();
        p['price'] = $('#CarfixSub_price').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('carfix/ajaxUpdateItem') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                if (data.msg == 1) {
                    $('#alert_frm').text(data.msgText).show();
                } else {
                    $('#myModal').modal('hide');
                    load_div_grid();
                }
            },
            error: function () {
                bootbox.alert('ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!');
            }
        });
        return true;
    }

    function delItem(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                p['carfix_id'] = $('#id').val();
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('carfix/ajaxDeleteItem') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        load_div_grid();
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }

    //รันเลขที่เอกสาร
    function docrun() {
        var p = {};
        p['docprefix_id'] = '3';
        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('docrun/ajaxGetDocNo') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                $('#Carfix_docno').val(data.docno);
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });

        return true;
    }
</script>