<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/chosen/chosen.jquery.min.js');

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jquery.numeric.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' ข้อมูลการใช้รถ';

$newORedit = ($model->id == '') ? 'เพิ่ม' : 'แก้ไข';
$this->breadcrumbs = array(
    'ข้อมูลการใช้รถ' => array('/carwork'),
    "บันทึกการใช้รถ ($newORedit)"
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';

$this->renderPartial('//layouts/hasFlash');
?>

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">
        <div class="tab-container">
            <ul class="nav nav-tabs">
                <li class="active"><a href="#tab1" data-toggle="tab">รายละเอียดการใช้รถ</a></li>
                <li><a href="#tab2" data-toggle="tab">รายละเอียดการรับคืน</a></li>
            </ul>
            <div class="tab-content" style='margin-bottom:10px;'>
                <div class="tab-pane active cont" id="tab1">
                    <div class="widget-toolbar">
                        <?php echo CHtml::link('<i class="fa fa-plus"></i> เพิ่มข้อมูล', array('carwork/create'), array('class' => 'btn btn-xs btn-success')); ?>
                        <?php
                        echo '<a href="#" onclick="return del(\'' . $model->id . '\')" class="btn btn-xs btn-danger"><i class="fa fa-trash-o"></i> ลบข้อมูล</a>';
                        ?>
                    </div>
                    <div class="clearfix"></div>
                    <hr style='margin-top:5px'/>
                    <?php
                    $form = $this->beginWidget('CActiveForm', array(
                        'id' => 'myform',
                        'enableClientValidation' => false,
                        'enableAjaxValidation' => false,
                        'htmlOptions' => array(
                            'class' => 'form-horizontal',
                            'enctype' => 'multipart/form-data',
                        ),
                        'action' => Yii::app()->createUrl('carwork/update'), //<- your form action here
                    ));
                    ?>

                    <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                    <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

                    <div class="form-group">
                        <label class="<?php echo $classLabel; ?>">ใบจองรถ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <label class="radio-inline" style='padding-left:0px;'> <input type="radio" <?php echo ($model->booking == '0') ? 'checked' : ''; ?> name="radBooking" class="icheck" value='0'> ไม่มี</label> 
                            <label class="radio-inline"> <input type="radio" <?php echo ($model->booking == '1') ? 'checked' : ''; ?> name="radBooking" class="icheck" value='1'> มี</label>
                        </div>

                        <label class="<?php echo $classLabel; ?>">สถานะงาน</label>
                        <div class="<?php echo $classDiv; ?>">
                            <label class="radio-inline" style='padding-left:0px'> <input type="radio" checked="" name="Carwork[status]" class="icheck" value='0' <?php echo ($model->status == '0') ? 'checked' : ''; ?>> อยู่ระหว่างใช้</label> 
                            <label class="radio-inline" style='padding-left:0px;margin-left: 5px'> <input type="radio" name="Carwork[status]" class="icheck" value='1' <?php echo ($model->status == '1') ? 'checked' : ''; ?>> เสร็จงาน/คืนรถ</label> 
                        </div>
                    </div>

                    <div class='form-group'>
                        <div id='divBooking'>
                            <label class="<?php echo $classLabel; ?>">เลขที่ใบจองรถ</label>
                            <div class="<?php echo $classDiv; ?>">
                                <?php
                                echo $form->hiddenField($model, 'booking_id');
                                $booking = Booking::model()->findByPk($model->booking_id);

                                $booking_docno = '';
                                if ($booking !== null) {
                                    $booking_docno = $booking->docno;
                                }
                                ?>
                                <div class="input-group">
                                    <input type='text' id='booking_docno' value='<?php echo $booking_docno; ?>' required="true" readonly="" class='form-control'>
                                    <span class="input-group-btn">
                                        <button type="button" class="btn btn-default" onclick="bookingModal()"><i class="fa fa-search"></i></button>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="<?php echo $classLabel; ?>">เลขที่เอกสาร<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'docno', array('class' => 'form-control', 'autofocus' => 'true', 'required' => 'true')); ?>
                                <span class="input-group-btn">
                                    <button type="button" class="btn btn-default" onclick="docrun()"><i class="fa fa-flash"></i></button>
                                </span>
                            </div>
                        </div>

                        <label class="<?php echo $classLabel; ?>">วันที่เวลา</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php
                            echo $form->hiddenField($model, 'docdate');
                            echo $form->hiddenField($model, 'doctime');
                            $model->docdate = MyDate::dateThaiShort($model->docdate);
                            ?>
                            <input type="text" value='<?php echo $model->docdate . " เวลา " . $model->doctime; ?>' class='form-control' readonly="" tabindex="-1"/>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">จองใช้รถเพื่อ<span class="required">*</span></label>
                        <div class="col-sm-10">
                            <?php echo $form->textField($model, 'working', array('class' => 'form-control', 'required' => 'true')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ทะเบียนรถ<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php
                            echo $form->hiddenField($model, 'car_id');
                            $car = Car::model()->findByPk($model->car_id);

                            $carCode = '';
                            if ($car !== null) {
                                $carCode = $car->code;
                            }
                            ?>
                            <div class="input-group">
                                <input type='text' id='car_code' value='<?php echo $carCode; ?>' required="true" readonly="" class='form-control'>
                                <span class="input-group-btn">
                                    <button type="button" class="btn btn-default" onclick="carModal()"><i class="fa fa-truck"></i></button>
                                </span>
                            </div>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">วันที่ใช้รถ<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group date">
                                <?php
                                $model->start_date = MyDate::dateToText($model->start_date);
                                echo $form->textField($model, 'start_date', array('class' => 'form-control', 'readonly' => 'true'));
                                ?>
                                <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                            </div>
                        </div>

                        <label class="<?php echo $classLabel; ?>">เวลา</label>
                        <div class="<?php echo $classDiv; ?>">
                            <table class="table table-condensed table-no-bordered no-margin">
                                <tr>
                                    <td class='no-padding'>
                                        <select class="form-control ddlTime" id="ddlStartH" name="ddlStartH">
                                            <?php
                                            for ($i = 0; $i < 24; $i++) {
                                                $t = sprintf('%02d', $i);
                                                $selected = '';
                                                if ($model->start_time != '') {
                                                    $selected = (substr($model->start_time, 0, 2) == $t) ? 'selected' : '';
                                                }
                                                echo "<option value='$t' $selected>$t</option>";
                                            }
                                            ?>
                                        </select>
                                    </td>
                                    <td class='no-padding'>
                                        <select class="form-control ddlTime" id="ddlStartM" name="ddlStartM">
                                            <?php
                                            for ($i = 0; $i < 56; $i+=5) {
                                                $t = sprintf('%02d', $i);
                                                $selected = '';
                                                if ($model->start_time != '') {
                                                    $selected = (substr($model->start_time, 3, 2) == $t) ? 'selected' : '';
                                                }
                                                echo "<option value='$t' $selected>$t</option>";
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ถึงวันที่<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group date">
                                <?php
                                $model->end_date = MyDate::dateToText($model->end_date);
                                echo $form->textField($model, 'end_date', array('class' => 'form-control', 'readonly' => 'true'));
                                ?>
                                <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                            </div>
                        </div>

                        <label class="<?php echo $classLabel; ?>">เวลา</label>
                        <div class="<?php echo $classDiv; ?>">
                            <table class="table table-condensed table-no-bordered no-margin">
                                <tr>
                                    <td class='no-padding'>
                                        <select class="form-control ddlTime" id="ddlEndH" name="ddlEndH">
                                            <?php
                                            for ($i = 0; $i < 24; $i++) {
                                                $t = sprintf('%02d', $i);
                                                $selected = ($t == '23') ? 'selected' : '';

                                                if ($model->end_time != '') {
                                                    $selected = (substr($model->end_time, 0, 2) == $t) ? 'selected' : '';
                                                }
                                                echo "<option value='$t' $selected>$t</option>";
                                            }
                                            ?>
                                        </select>
                                    </td>
                                    <td class='no-padding'>
                                        <select class="form-control ddlTime" id="ddlEndM" name="ddlEndM">
                                            <?php
                                            for ($i = 0; $i < 56; $i+=5) {
                                                $t = sprintf('%02d', $i);
                                                $selected = ($t == '55') ? 'selected' : '';

                                                if ($model->end_time != '') {
                                                    $selected = (substr($model->end_time, 3, 2) == $t) ? 'selected' : '';
                                                }
                                                echo "<option value='$t' $selected>$t</option>";
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">สถานที่ไป<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'address', array('class' => 'form-control', 'placeholder' => 'ที่อยู่ หรือชื่อสถานที่', 'required' => 'true')); ?>
                        </div>

                        <label class="<?php echo $classLabel; ?>">ตำบล</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'tumbol', array('class' => 'form-control')); ?>
                        </div>
                    </div>


                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">อำเภอ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'aumphur', array('class' => 'form-control')); ?>
                        </div>

                        <label class="<?php echo $classLabel; ?>">จังหวัด<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <select name="Carwork[province]" id='Carwork_province' data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control" required="" title='คุณต้องเลือกจังหวัด'>
                                <option value=""></option>
                                <?php
                                $provinces = Province::model()->findAll(array('order' => 'name asc'));
                                foreach ($provinces as $r) {
                                    $selected = ($model->province == $r->name) ? 'selected' : '';
                                    echo "<option value='$r->name' $selected>$r->name</option>";
                                }
                                ?>
                            </select>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ใช้สำหรับแผนก</label>
                        <div class="<?php echo $classDiv; ?>">
                            <select name="Carwork[depart_id]" id='Carwork_depart_id' data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control" required="" title='คุณต้องเลือกจังหวัด'>
                                <option value=""></option>
                                <?php
                                $departs = Depart::model()->findAll(array('order' => 'name asc'));
                                foreach ($departs as $r) {
                                    $selected = ($model->depart_id == $r->id) ? 'selected' : '';
                                    echo "<option value='$r->id' $selected>$r->name</option>";
                                }
                                ?>
                            </select>
                        </div>

                        <label class="<?php echo $classLabel; ?>">จำนวนผู้โดยสาร</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'passenger_amount', array('class' => 'form-control numeric')); ?>
                                <span class="input-group-addon">คน</span>
                            </div>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">รายชื่อผู้โดยสาร</label>
                        <div class="col-sm-10">
                            <?php echo $form->textArea($model, 'passenger_name', array('rows' => 2, 'class' => 'form-control')); ?>
                        </div>
                    </div>


                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">เอกสารอ้างอิง</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'docref', array('class' => 'form-control')); ?>
                        </div>

                        <label class="<?php echo $classLabel; ?>">พนักงานขับรถ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <select name="Carwork[driver_id]" id='Carwork_driver_id' data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control">
                                <option value=""></option>
                                <?php
                                $drivers = Driver::model()->findAll(array('condition' => 'status = 0', 'order' => 'firstname asc'));
                                foreach ($drivers as $r) {
                                    $selected = ($model->driver_id == $r->id) ? 'selected' : '';
                                    echo "<option value='$r->id' $selected>" . $r->title . $r->firstname . " " . $r->surname . "</option>";
                                }
                                ?>
                            </select>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ผู้ขอใช้</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'person_name', array('class' => 'form-control')); ?>
                        </div>

                        <label class="<?php echo $classLabel; ?>">โทรศัพท์ติดต่อ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'tel', array('class' => 'form-control')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ข้อมูลการใช้รถ/การปฏิบัติงาน</label>
                        <div class="col-sm-10">
                            <?php echo $form->textArea($model, 'work_comment', array('rows' => 2, 'class' => 'form-control')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">เลขไมล์ก่อนใช้</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'start_km', array('class' => 'form-control numeric')); ?>
                        </div>

                        <label class="<?php echo $classLabel; ?>">เลขไมล์หลังใช้</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'end_km', array('class' => 'form-control numeric')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">จำนวนน้ำมัน</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'amount_oil', array('class' => 'form-control numeric')); ?>
                                <span class="input-group-addon">ลิตร</span>
                            </div>
                        </div>

                        <label class="<?php echo $classLabel; ?>">ราคา:ลิตร</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class='input-group'>
                                <?php echo $form->textField($model, 'oil_rate', array('class' => 'form-control numeric')); ?>
                                <span class="input-group-addon">บาท</span>
                            </div>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ค่าใช้จ่ายอื่นๆ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'pay_outcome', array('class' => 'form-control numeric')); ?>
                                <span class="input-group-addon">บาท</span>
                            </div>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">รายการค่าใช้จ่าย</label>
                        <div class="col-sm-10">
                            <?php echo $form->textArea($model, 'outcome_comment', array('rows' => 2, 'class' => 'form-control')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">รายรับ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'pay_income', array('class' => 'form-control numeric')); ?>
                                <span class="input-group-addon">บาท</span>
                            </div>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">รายการรายรับ</label>
                        <div class="col-sm-10">
                            <?php echo $form->textArea($model, 'income_comment', array('rows' => 2, 'class' => 'form-control')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">อัตราค่าเช่า</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php
                                $model->car_rate = number_format($model->car_rate, 2);
                                echo $form->textField($model, 'car_rate', array('class' => 'form-control numeric', 'readonly' => 'true'));
                                ?>
                                <span class="input-group-addon">บาท:นาที</span>
                            </div>
                        </div>

                        <label class="<?php echo $classLabel; ?>">ค่าเช่าสทุธิ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php
                                $model->car_money = number_format($model->car_money, 2);
                                echo $form->textField($model, 'car_money', array('class' => 'form-control numeric', 'readonly' => 'true'));
                                ?>
                                <span class="input-group-addon">บาท</span>
                            </div>
                        </div>
                    </div>

                    <div class="form-actions form-actions-gt">
                        <div class="row no-margin">
                            <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                                <i class="fa fa-save"></i>
                                บันทึกข้อมูล
                            </button>
                        </div>
                    </div>

                    <?php $this->endWidget(); ?>
                </div>  <!-- end tab1 -->

                <div class="tab-pane cont" id="tab2">
                    <?php
                    $showReturn = FALSE;
                    if ($model->booking == '1' && $model->booking_id != '') {
                        $booking = Booking::model()->findByPk($model->booking_id);
                        if ($booking != null) {
                            $showReturn = TRUE;
                        }
                    }
                    ?>

                    <?php if ($showReturn): ?>
                        <table class="no-strip no-border">
                            <tbody class=''>
                                <tr>
                                    <td width='140'><strong>สถานะ</strong></td>
                                    <td>
                                        <?php
                                        if ($booking->status == '6') {
                                            echo '<span class="label label-success">รับคืนรถแล้ว</span>';
                                        } else {
                                            echo '<span class="label label-warning">ยังไม่รับคืนรถ</span>';
                                        }
                                        ?>
                                    </td>
                                </tr>
                                <tr>
                                    <td><strong>วันเวลาตรวจรับ</strong></td>
                                    <td>
                                        <?php
                                        if ($booking->status == '6') {
                                            echo MyDate::dateThaiShort($booking->date_return_ok) . " " . date("H:i", strtotime($booking->date_return_ok));
                                        }
                                        ?>
                                    </td>
                                </tr>
                                <tr>
                                    <td><strong>อัตราค่าเช่า</strong></td>
                                    <td>
                                        <?php echo number_format($booking->car_rate, 2); ?> <strong> บาท:นาที</strong>
                                        <strong style='margin-left:20px'> ค่าเช่าสทุธิ </strong>
                                        <?php echo number_format($booking->car_money, 2); ?> <strong> บาท</strong>
                                    </td>
                                </tr>
                                <tr>
                                    <td><strong>ค่าปรับอื่นๆ</strong></td>
                                    <td><?php echo number_format($booking->damage, 2); ?> <strong> บาท</strong></td>
                                </tr>
                                <tr>
                                    <td><strong>ส่วนลด</strong></td>
                                    <td><?php echo number_format($booking->discount, 2); ?> <strong> บาท</strong></td>
                                </tr>
                                <tr>
                                    <td><strong>หมายเหตุรับคืน</strong></td>
                                    <td><?php echo $booking->return_comment; ?></td>
                                </tr>
                            </tbody>
                        </table>
                    <?php else: ?>
                        <div class='alert alert-warning'><h4 style='margin: 0px;text-align: center;'>ไม่ได้เชื่อมรายการจอง</h4></div>
                    <?php endif; ?>

                </div>  <!-- end tab2 -->
            </div>  <!-- end tab content -->
        </div>  <!-- end tab containger -->
    </div>
</div>

<!-- Modal Car -->
<?php $this->renderPartial('//car/modalCar'); ?>

<!-- Modal Booking-->
<?php $this->renderPartial('//booking/modalBooking'); ?>

<script type='text/javascript'>
    $(document).ready(function () {
        $(".numeric").numeric({negative: false});

        $(".chzn-select-deselect").chosen({
            allow_single_deselect: true,
            no_results_text: 'ไม่พบรายชื่อ!',
            search_contains: true
        });

        $('#myform').validate({ignore: ":hidden:not(select)",
            invalidHandler: function (event, validator) {
                loadingStaticRemove();
            }
        });

        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            orientation: "top auto",
            format: "dd/mm/yyyy"
        });

        $('input[name=radBooking]').on('ifChecked', function () {
            divBooking($(this).val());
        });

        var statusBooking = "<?php echo $model->booking; ?>";
        divBooking(statusBooking);
    });

    function divBooking(status) {
        if (status == '0') {
            $('#Carwork_booking_id').val('');
            //$('#booking_docno').val('');

            $("#divBooking").hide();
        } else {
            $("#divBooking").show();
        }
    }

    function save() {
        var ret = '';
        if ($('#car_code').val() == '') {
            ret += 'คุณต้องเลือกรถที่ต้องการก่อน<br/>';
        }

        if (parseInt($('#Carwork_end_km').val()) < parseInt($('#Carwork_start_km').val())) {
            ret += 'เลขไมล์หลังใช้ <strong>ต้องมากกว่า</strong> เลขไมล์ก่อนใช้';
        }


        if (ret != '') {
            bootbox.alert(artalert('warning', ret));
        } else {
            var p = {};
            p['save'] = true;

            p['id'] = $('#id').val();
            p['code'] = $('#Carwork_docno').val();

            $.ajax({
                data: p,
                url: "<?php echo Yii::app()->createUrl('carwork/ajaxValidate') ?>",
                type: 'POST',
                dataType: 'json',
                success: function (data) {
                    scrollToTop();
                    if (data.msg == '0') {
                        loadingStatic();
                        $('#myform').submit();
                    } else {
                        bootbox.alert(artalert('danger', data.msgText));
                    }
                },
                error: function () {
                    bootbox.alert(artalert('danger', 'ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!'));
                }});
        }
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('carwork/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        window.location.href = "<?php echo Yii::app()->createUrl('carwork/create'); ?>"
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }

    //เปิด Modal Car
    function carModal() {
        loadGridCarModal();
        $('.modal').on('shown.bs.modal', function () {
            $('#txtsearchCarModal').focus();
        });
        $('#myModalCar').modal({show: true});
    }

    //เลือกหมวดจาก modal
    function carModalSelect(id, code) {
        $('#Carwork_car_id').val(id);
        $('#car_code').val(code);
        $('#myModalCar').modal('hide');

        getCalculate(id);
    }

    //เปิด Modal Booking
    function bookingModal() {
        $('#divWarningModalBooking').show();
        var frameSrc = "<?php echo Yii::app()->createUrl('booking/modal') ?>";
        $('.modal').on('shown.bs.modal', function () {
            $('#myModalBooking iframe').attr('height', getModalHeight());

            $('.modal .modal-body').css('height', getModalHeightBody());
            $('#myModalBooking iframe').attr("src", frameSrc);
        });
        $('#myModalBooking').modal({show: true});
    }

    //เลือกหมวดจาก modal
    function bookingModalSelect(p) {
        $('#Carwork_booking_id').val(p['id']);
        $('#booking_docno').val(p['code']);

        getDetailBooking(p['id']);
    }

    function getDetailBooking(booking_id) {
        //กำหนดค่าให้ text กรณีเลือกรายการจอง
        var p = {};
        p['booking_id'] = booking_id;
        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('carwork/ajaxGetBookingDetail') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                $('#Carwork_working').val(data.working);
                $('#car_code').val(data.car_code);
                $('#Carwork_car_id').val(data.car_id);
                $('#Carwork_start_date').val(data.start_date);
                $('#Carwork_end_date').val(data.end_date);
                $('#ddlStartH').val(data.ddlStartH);
                $('#ddlStartM').val(data.ddlStartM);
                $('#ddlEndH').val(data.ddlEndH);
                $('#ddlEndM').val(data.ddlEndM);
                $('#Carwork_address').val(data.address);
                $('#Carwork_tumbol').val(data.tumbol);
                $('#Carwork_aumphur').val(data.aumphur);
                $('#Carwork_passenger_amount').val(data.passenger_amount);
                $('#Carwork_passenger_name').val(data.passenger_name);
                $('#Carwork_docref').val(data.docref);
                $('#Carwork_driver_id').val(data.driver_id);
                $('#Carwork_person_name').val(data.person_name);
                $('#Carwork_tel').val(data.tel);

                $('#Carwork_province').val(data.province);
                $('#Carwork_depart_id').val(data.depart_id);
                $('.chzn-select-deselect').trigger("liszt:updated");

                //$('#teacher_code').val(teacher_code);
                $('select').trigger("chosen:updated");

                getCalculate(data.car_id);
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถดึงค่ารายการจองได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });
    }

    //คำนวนค่าเช่า
    function getCalculate(car_id) {
        var p = {};
        p['car_id'] = car_id;
        p['start_date'] = $('#Carwork_start_date').val();
        p['start_time_f'] = $('#ddlStartH').val();
        p['start_time_e'] = $('#ddlStartM').val();

        p['end_date'] = $('#Carwork_end_date').val();
        p['end_time_f'] = $('#ddlEndH').val();
        p['end_time_e'] = $('#ddlEndM').val();
        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('car/ajaxGetCalculate') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                $('#Carwork_car_rate').val(data.car_rate);
                $('#Carwork_car_money').val(data.car_money);
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });
    }

    //รันเลขที่เอกสาร
    function docrun() {
        var p = {};
        p['docprefix_id'] = '2';
        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('docrun/ajaxGetDocNo') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                $('#Carwork_docno').val(data.docno);
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });

        return true;
    }
</script>