<?php
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap-inputmask.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' ข้อมูลการใช้รถ';
$this->breadcrumbs = array(
    'ข้อมูลการใช้รถ'
);
?>

<div class="row">
    <div class="col-sm-12 col-md-12">
        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-table"></i></span>
                <h2>ข้อมูลการใช้รถ</h2>
                <div class="widget-toolbar">
                    <?php echo CHtml::link('<i class="fa fa-plus"></i> เพิ่มรายการ', array('carwork/create'), array('class' => 'btn btn-xs btn-success')); ?>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class="row">
                    <div class="col-md-12">
                        <div class="form-group col-sm-6 col-md-3 padding-small">
                            <label>จากวันที่ใช้รถ</label>
                            <div class="input-group date">
                                <input class="form-control" size="16" type="text" id="start_date" name="start_date" placeholder="วว/ดด/ปี พ.ศ." value='<?php echo $carwork_start_date;?>'/>
                                <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                            </div>
                        </div>
                        <div class="form-group col-sm-6 col-md-3 padding-small">
                            <label>ถึงวันที่</label>
                            <div class="input-group date">
                                <input class="form-control" size="16" type="text" id="end_date" name="end_date" placeholder="วว/ดด/ปี พ.ศ." value='<?php echo $carwork_end_date;?>'>
                                <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                            </div>
                        </div>
                        <div class="form-group col-sm-6 col-md-6 padding-small">
                            <label>ค้นหา</label>
                            <div class="input-group">
                                <input class="form-control" type="text" id="txtsearch" placeholder="เลขที่เอกสาร, ทะเบียน, ใช้รถเพื่อ" autofocus="true" value='<?php echo $carwork_car;?>'/>
                                <span class="input-group-btn">
                                    <button type="button" class="btn btn-primary" onclick="load_div_grid()"><i class="fa fa-search"></i> ค้นหา</button>
                                </span>
                            </div>
                        </div>
                    </div>
                </div>

                <div id="div_grid">
                    <?php $this->renderPartial('_gridview', array('grids' => $grids)); ?>
                </div>
            </div>

        </div>

    </div>
</div>

<!-- Modal -->
<div class="modal fade colored-header" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<script type='text/javascript'>
    $(function () {
        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            orientation: "top auto",
            format: "dd/mm/yyyy"
        });

        $('#txtsearch').keydown(function (e) {
            if ((e.keyCode == 13)) {
                load_div_grid();
                return true;
            }
        });
    });

    function load_div_grid(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('carwork/ajaxList') ?>";
        var p = {};
        p['txtsearch'] = $('#txtsearch').val();
        p['start_date'] = $('#start_date').val();
        p['end_date'] = $('#end_date').val();

        $('#div_grid').load(url, p);
        $('#txtsearch').focus();
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('carwork/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        load_div_grid();
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }
</script>