<?php
$this->pageTitle = Yii::app()->name . ' แผนก';

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrapvalidator/bootstrapValidator.min.js', CClientScript::POS_END);
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/chosen/chosen.jquery.min.js');

$this->breadcrumbs = array(
    'แผนก'
);
?>
<div class="row">
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-table"></i></span>
                <h2>แผนก</h2>	
                <div class="widget-toolbar">
                    <a href="javascript:void(0);" onclick='create();' class="btn btn-xs btn-success"><i class="fa fa-plus"></i> เพิ่มข้อมูล</a>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class="row">
                    <div class="col-xs-12 col-md-8 col-lg-6">
                        <div class="input-group">
                            <input class="form-control" type="text" id="txtsearch" placeholder="ค้นหา..." autofocus="true">
                            <span class="input-group-btn">
                                <button type="button" class="btn btn-primary" onclick="load_div_grid()"><i class="fa fa-search"></i> ค้นหา</button>
                            </span>
                        </div>
                    </div>
                </div>
                <div id="div_grid">
                    <?php $this->renderPartial('_gridview', array('grids' => $grids)); ?>
                </div>
            </div>

        </div>

    </div>
</div>

<!-- Modal -->
<div class="modal fade colored-header" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<script type='text/javascript'>
    $(function () {
        $('#txtsearch').keydown(function (e) {
            if ((e.keyCode == 13)) {
                load_div_grid();
                return true;
            }
        });

        $('.modal').on('shown.bs.modal', function () {
            $('.chzn-select', this).chosen({
                allow_single_deselect: true,
                no_results_text: 'ไม่พบรายชื่อ!',
                search_contains: true
            });
            $(this).find("[autofocus]:first").focus();
        });
    });

    function load_div_grid(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('depart/ajaxList') ?>";
        var p = {};
        p['txtsearch'] = $('#txtsearch').val();

        $('#div_grid').load(url, p);
        $('#txtsearch').focus();
        return true;
    }

    function create() {
        $('#myModal').load("<?php echo Yii::app()->createUrl('depart/ajaxCreate') ?>", function () {
            $('#myModal').modal('show');
        });
        return true;
    }

    function update(id) {
        var p = {};
        p['id'] = id;
        $('#myModal').load("<?php echo Yii::app()->createUrl('depart/ajaxUpdate') ?>", p, function () {
            $('#myModal').modal('show');
        });
        return true;
    }

    function save() {
        var p = {};
        p['save'] = true;
        p['id'] = $('#id').val();
        p['faculty_id'] = $('#faculty_id').val();
        p['code'] = $('#Depart_code').val();
        p['name'] = $('#Depart_name').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('depart/ajaxUpdate') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                if (data.msg == 1) {
                    $('#alert_frm').text(data.msgText).show();
                } else {
                    $('#myModal').modal('hide');
                    load_div_grid();
                }
            },
            error: function () {
                bootbox.alert('ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!');
            }
        });
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('depart/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function (data) {
                        if (data.msg === '1') {
                            bootbox.alert('<div class="alert alert-danger">' + data.msgText + "</div>");
                        } else {
                            load_div_grid();
                        }
                    },
                    error: function () {
                        bootbox.alert('ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!');
                    }
                });
            }
        });

        return true;
    }
</script>