<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap-inputmask.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' รายละเอียดพนักงานขับรถ';

$newORedit = ($model->id == '') ? 'เพิ่ม' : 'แก้ไข';
$this->breadcrumbs = array(
    'ข้อมูลพนักงานขับรถ' => array('/driver'),
    "รายละเอียดพนักงานขับรถ ($newORedit)"
);

$classLabel = 'col-sm-3 col-md-3 control-label';
$classDiv = 'col-sm-9 col-md-9';

$this->renderPartial('//layouts/hasFlash');
?>

<style>
    .div-image-center{
        background-color: #FFF;
        width: 150px;
        height: 150px;
        line-height: 150px;
        text-align: center;
    }
</style>

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดพนักงานขับรถ</h2>	
                <div class="widget-toolbar">
                    <?php echo CHtml::link('<i class="fa fa-plus"></i> เพิ่มข้อมูล', array('driver/create'), array('class' => 'btn btn-xs btn-success')); ?>
                    <?php
                    echo '<a href="#" onclick="return del(\'' . $model->id . '\')" class="btn btn-xs btn-danger"><i class="fa fa-trash-o"></i> ลบข้อมูล</a>';
                    ?>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $form = $this->beginWidget('CActiveForm', array(
                    'id' => 'myform',
                    'enableClientValidation' => false,
                    'enableAjaxValidation' => false,
                    'htmlOptions' => array(
                        'class' => 'form-horizontal',
                        'enctype' => 'multipart/form-data',
                    ),
                    'action' => Yii::app()->createUrl('driver/update'), //<- your form action here
                ));
                ?>

                <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

                <div class='col-md-8'>
                    <div class="form-group">
                        <label class="<?php echo $classLabel; ?>">สถานะ</label>
                        <div class="col-sm-6 col-md-4 col-lg-3">
                            <select name="Driver[status]" class='form-control'>
                                <option value="0" <?php if ($model->status == '0') echo 'selected'; ?>>ปกติ</option>
                                <option value="1" <?php if ($model->status == '1') echo 'selected'; ?>>ห้ามขับรถ</option>
                            </select>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="<?php echo $classLabel; ?>">รหัส<span class="required">*</span></label>
                        <div class="col-sm-5 col-md-5 col-lg-5">
                            <?php echo $form->textField($model, 'code', array('class' => 'form-control', 'autofocus' => 'true', 'required' => 'true')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">คำนำหน้า<span class="required">*</span></label>
                        <div class="col-sm-5 col-md-5 col-lg-5">
                            <?php echo $form->textField($model, 'title', array('class' => 'form-control', 'required' => 'true')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ชื่อ<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'firstname', array('class' => 'form-control', 'required' => 'true')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">นามสกุล<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'surname', array('class' => 'form-control', 'required' => 'true')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ชื่อเล่น</label>
                        <div class="col-sm-5 col-md-5 col-lg-5">
                            <?php echo $form->textField($model, 'nickname', array('class' => 'form-control')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">เลขบัตรประชาชน</label>
                        <div class="col-sm-5 col-md-5 col-lg-5">
                            <?php
                            echo $form->textField($model, 'idcard', array('class' => 'form-control',
                                'data-mask' => '9-9999-99999-99-9'));
                            ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">วันที่ใบขับขี่</label>
                        <div class="col-sm-5 col-md-5 col-lg-5">
                            <?php
                            $model->datef = MyDate::dateToText($model->datef);
                            echo $form->textField($model, 'datef', array('class' => 'form-control',
                                'data-mask' => '99/99/9999',
                                'placeholder' => 'วันที่ วว/ดด/ปป ปีพ.ศ.'));
                            ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">วันที่หมดอายุ</label>
                        <div class="col-sm-5 col-md-5 col-lg-5">
                            <?php
                            $model->datet = MyDate::dateToText($model->datet);
                            echo $form->textField($model, 'datet', array('class' => 'form-control',
                                'data-mask' => '99/99/9999',
                                'placeholder' => 'วันที่ วว/ดด/ปป ปีพ.ศ.'));
                            ?>
                        </div>
                    </div>

                     <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">โทรศัพท์</label>
                        <div class="col-sm-5 col-md-5 col-lg-5">
                            <?php
                            echo $form->textField($model, 'tel', array('class' => 'form-control'));
                            ?>
                        </div>
                    </div>
                    
                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">คำอธิบายเพิ่มเติม</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textArea($model, 'comment', array('rows' => 2, 'class' => 'form-control')); ?>
                        </div>
                    </div>
                </div>

                <div class="col-md-4">
                    <div class="well well-sm">
                        <?php
                        $baseUrl = Yii::app()->request->baseUrl;
                        $imagePath = Driver::model()->getImagePath($model->id);
                        ?>

                            <div style="text-align:center">
                                <div class="fileinput fileinput-new" data-provides="fileinput" style="margin-left:5px;">
                                    <div class="fileinput-new thumbnail div-image-center">
                                        <img src="<?php echo $imagePath; ?>" alt="ภาพประจำตัว" class="img-responsive">
                                    </div>
                                    <div class="fileinput-preview fileinput-exists thumbnail div-image-center"></div>
                                    <div>
                                        <span class="btn btn-default btn-file"><span class="fileinput-new"><i class="fa fa-picture-o"></i> เลือกรูปประจำตัว</span><span class="fileinput-exists">เปลี่ยน</span><input type="file" name="<?php echo "picture1"; ?>"></span>
                                        <a href="#" class="btn btn-default fileinput-exists" data-dismiss="fileinput">ยกเลิก</a>
                                    </div>
                                </div>
                            </div>
                        <div class="alert alert-info text-center">ขนาดภาพที่เหมาะสมคือ<br/>150 x 150 pixel</div>
                      
                    </div>
                </div>

                <div class='clearfix'></div>
                <div class="form-actions form-actions-gt">
                    <div class="row no-margin">
                        <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                            <i class="fa fa-save"></i>
                            บันทึกข้อมูล
                        </button>
                    </div>
                </div>

                <?php $this->endWidget(); ?>
            </div>

        </div>

    </div>
</div>

<!-- Modal -->
<div class="modal fade colored-header" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<script type='text/javascript'>
    $(document).ready(function () {
        $('#myform').validate({
            invalidHandler: function (event, validator) {
                loadingStaticRemove();
            }
        });
    });

    function save() {
        var p = {};
        p['save'] = true;
        p['id'] = $('#id').val();
        p['code'] = $('#Driver_code').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('driver/ajaxValidate') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                scrollToTop();
                if (data.msg == '0') {
                    loadingStatic();
                    $('#myform').submit();
                } else {
                    bootbox.alert(artalert('danger', data.msgText));
                }
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('driver/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        window.location.href = "<?php echo Yii::app()->createUrl('driver/create'); ?>"
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }
</script>