<?php
$this->pageTitle = Yii::app()->name . ' นำเข้ารายชื่อผู้ใช้';
$this->breadcrumbs = array(
    'นำเข้ารายชื่อผู้ใช้'
);
?>
<div class="row">
    <div class="col-sm-12 col-md-12">
        <div class="block-flat">
            <?php if (Yii::app()->user->hasFlash('success')): ?>
                <div class="alert alert-success"><?php echo Yii::app()->user->getFlash('success'); ?></div>
            <?php endif; ?>
            <header>
                <span class="widget-icon"> <i class="fa fa-download"></i></span>
                <h2>นำเข้ารายชื่อผู้ใช้</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <form id='formUploadFile' action="<?php echo Yii::app()->createUrl('import/process'); ?>" 
                      method="post" enctype="multipart/form-data" 
                      class='form-horizontal'>

                    <div class="form-group">
                        <label class="col-md-2 control-label">เลือกไฟล์</label>
                        <div class="col-md-10">
                            <input type="file" id='file_upload' name="file_upload"/>
                            <p class="text-muted" style="padding-top: 10px">เฉพาะไฟล์นามสกุล csv</p>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-2 control-label"></label>
                        <div class="col-md-10">
                            <button type="submit" id="submit-btn" class="btn btn-primary"><i class='fa fa-play'></i> เริ่มขบวนการตรวจสอบ</button>
                        </div>
                    </div>
                </form>
            </div>
        </div>  <!-- end block-flat -->

        <?php if (isset($models)): ?>
            <div class="block-flat">
                <div class='content'>
                    <?php if (Yii::app()->user->hasFlash('error')): ?>
                        <div class="alert alert-danger">
                            <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                            <i class="fa fa-times-circle sign"></i> <strong>ไม่สามารถนำเข้าข้อมูลได้เนื่องจาก</strong>
                            <br/><?php echo Yii::app()->user->getFlash('error'); ?>
                        </div>
                    <?php else: ?>
                        <div class="alert alert-success">
                            <b><i class="fa fa-check"></i> รูปแบบถูกต้อง</b> (สามารถนำเข้าข้อมูลได้โดยคลิกปุ่ม <b>นำเข้าข้อมูล</b> ด้านล่างนี้)
                        </div>
                        <p>
                        <form id='saveProcess' action="<?php echo Yii::app()->createUrl('import/saveProcess'); ?>" 
                              method="post">
                            <button type="submit" id="submit-btn" class="btn btn-success"><i class='fa fa-save'></i> นำเข้าข้อมูล</button>
                        </form>

                        </p>
                    <?php endif; ?>

                    <div class='table-responsive'>
                        <table class='table table-bordered th-bg hover'>
                            <thead>
                                <tr>
                                    <th>1</th>
                                    <th>รหัสแผนก</th>
                                    <th>รหัสผู้ใช้</th>
                                    <th>คำนำหน้าชื่อ</th>
                                    <th>ชื่อ</th>
                                    <th>นามสกุล</th>
                                    <th>ชื่อเล่น</th>
                                    <th>ตำแหน่ง</th>
                                    <th>โทรศัพท์</th>
                                    <th>อีเมลล์</th>
                                    <th>ชื่อเข้าใช้ระบบ</th>
                                    <th>รหัสผ่าน</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $irow = 1;
                                foreach ($models as $r) {
                                    $irow++;
                                    echo "<tr>";
                                    echo "<td>$irow</id>";
                                    echo "<td>" . $r['depart_code'] . "</id>";
                                    echo "<td>" . $r['code'] . "</id>";
                                    echo "<td>" . $r['title'] . "</id>";
                                    echo "<td>" . $r['firstname'] . "</id>";
                                    echo "<td>" . $r['surname'] . "</id>";
                                    echo "<td>" . $r['nickname'] . "</id>";
                                    echo "<td>" . $r['position_name'] . "</id>";
                                    echo "<td>" . $r['tel'] . "</id>";
                                    echo "<td>" . $r['email'] . "</id>";
                                    echo "<td>" . $r['username'] . "</id>";
                                    echo "<td>" . $r['password'] . "</id>";
                                    echo "</tr>";
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>

                </div>  <!-- end block-flat content -->
            </div>  <!-- end block-flat -->
        <?php endif; ?>

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-file-text"></i></span>
                <h2>รูปแบบไฟล์ CSV</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class="row">
                    <div class="col-md-12">
                        <img src ="<?php echo Yii::app()->request->baseUrl; ?>/tmp/sample_csv.png" class="img-responsive col-md-12"/>
                    </div>
                    <div class="col-md-12">
                        <table class='table table-bordered th-bg hover'>
                            <thead>
                                <tr>
                                    <th width="40">ลำดับ</th>
                                    <th>ควาหมาย</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr><td>1</td><td>รหัสแผนก <span class="text-danger">(จำเป็นต้องกรอก)</span></td></tr>
                                <tr><td>2</td><td>รหัสผู้ใช้ <span class="text-danger">(จำเป็นต้องกรอก)</span></td></tr>
                                <tr><td>3</td><td>คำนำหน้าชื่อ <span class="text-danger">(จำเป็นต้องกรอก)</span></td></tr>
                                <tr><td>4</td><td>ชื่อ <span class="text-danger">(จำเป็นต้องกรอก)</span></td></tr>
                                <tr><td>5</td><td>นามสกุล <span class="text-danger">(จำเป็นต้องกรอก)</span></td></tr>
                                <tr><td>6</td><td>ชื่อเล่น</td></tr>
                                <tr><td>7</td><td>ตำแหน่ง</td></tr>
                                <tr><td>8</td><td>โทรศัพท์</td></tr>
                                <tr><td>9</td><td>อีเมลล์</td></tr>
                                <tr><td>10</td><td>ชื่อเข้าใช้ระบบ <span class="text-danger">(จำเป็นต้องกรอก)</span></td></tr>
                                <tr><td>11</td><td>รหัสผ่าน <span class="text-warning">(ถ้าเป็นค่าว่างระบบกำหนดรหัสให้เป็น 1234)</span></td></tr>
                            </tbody>
                        </table>
                        <div class="alert alert-warning">
                            <b>ข้อควรจำ: </b>
                            <ul>
                                <li>ข้อมูลจะต้องมีทั้งหมด 11 column โดยแต่ละ column จะถูกคั้นด้วยเครื่องหมาย <b>, คอมม่า</b></li>
                                <li>บรรทัดแรกให้กรอกเป็นคำอธิบาย column ดังภาพ</li>
                                <li>โปรแกรมจะนำเข้าข้อมูลตั้งแต่บรรทัดที่ 2 (หากไม่กรอกคำอธิบาย column ในบรรทัดที่ 1 ให้เคาะบรรทัดลงมา)</li>
                                <li>ไฟล์ CSV สามารถสร้างได้ด้วยโปรแกรม Microsoft Excel แล้วบันทึกเป็น CSV (Comma delimited) (*.csv)</li>
                                <li>ไฟล์ CSV ที่ได้อาจจะไม่ได้ถูกเข้ารหัส UTF-8 (หมายความว่า ภาษาไทยจะใช้งานไม่ได้) ดังนั้นให้ใช้โปรแกรม Notepad เปิดไฟล์แล้วบันทึกใหม่ โดยให้เลือกรูปแบบ Encoding  เป็น UTF-8</li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
        </div>  <!-- end block-flat -->

    </div>  <!-- end col -->
</div>