<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/fancyapp/source/jquery.fancybox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/fancyapp/source/jquery.fancybox.pack.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/fancyapp/lib/jquery.mousewheel-3.0.6.pack.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' รายละเอียดรถ';
$this->breadcrumbs = array(
    'รายการรถ' => array('/query/car'),
    "รายละเอียดรถ"
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';
?>

<style>
    .div-image-center{
        background-color: #FFF;
        width: 200px;
        height: 150px;
        line-height: 150px;
        text-align: center;
    }
</style>

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดรถ</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class="table-responsive">
                    <table class='table'>
                        <tbody>
                            <tr>
                                <td width='130'><b>ทะเบียน</b></td>
                                <td width='25%'><?php echo $model->code; ?></td>
                                <td width='140'><b>จังหวัด</b></td>
                                <td>
                                    <?php
                                    $province = Province::model()->findByAttributes(array('code' => $model->prov_code));
                                    if ($province != null) {
                                        echo $province->name;
                                    }
                                    ?>
                                </td>
                            </tr>

                            <tr>
                                <td><b>หมายเลขรถ</b></td>
                                <td><?php echo $model->carno; ?></td>
                                <td><b>สถานะ</b></td>
                                <td><?php echo Car::model()->getStatusText($model->status); ?></td>
                            </tr>

                            <tr>
                                <td><b>ประเภทรถ</b></td>
                                <td>
                                    <?php
                                    $cartype = Cartype::model()->findByAttributes(array('id' => $model->cartype_id));
                                    if ($cartype != null) {
                                        echo $cartype->name;
                                    }
                                    ?>
                                </td>
                                <td><b>ยี่ห้อ</b></td>
                                <td>
                                    <?php
                                    $brand = Brand::model()->findByAttributes(array('id' => $model->brand_id));
                                    echo $brand->name;
                                    ?>
                                </td>
                            </tr>

                            <tr>
                                <td><b>เชื้อเพลิง</b></td>
                                <td>
                                    <?php
                                    $oil = Oil::model()->findByAttributes(array('id' => $model->oil_id));
                                    echo $oil->name;
                                    ?>
                                </td>
                                <td><b>สี</b></td>
                                <td><?php echo $model->color; ?></td>
                            </tr>

                            <tr>
                                <td><b>รุ่น</b></td>
                                <td colspan='3'><?php echo $model->model; ?></td>
                            </tr>

                            <tr>
                                <td><b>เลขเครื่อง</b></td>
                                <td><?php echo $model->machine_no; ?></td>
                                <td><b>เลขตัวถัง</b></td>
                                <td><?php echo $model->machine_tank; ?></td>
                            </tr>

                            <tr>
                                <td><b>ราคา</b></td>
                                <td><?php echo number_format($model->price); ?>&nbsp;&nbsp;<b>บาท</b></td>
                                <td><b>อัตราค่าเช่า</b></td>
                                <td><?php echo number_format($model->rate, 2); ?>&nbsp;&nbsp;<b>บาท:นาที</b></td>
                            </tr>

                            <tr>
                                <td><b>วันที่ซื้อ</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_buy); ?></td>
                                <td><b>วันที่รับเข้า</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_in); ?></td>
                            </tr>

                            <tr>
                                <td><b>วันที่จดทะเบียน</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_f_code); ?></td>
                                <td><b>ทะเบียนหมดอายุ</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_e_code); ?></td>
                            </tr>

                            <tr>
                                <td><b>วันทำ พ.ร.บ.</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_f_cpi); ?></td>
                                <td><b>พ.ร.บ. หมดอายุ</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_e_cpi); ?></td>
                            </tr>

                            <tr>
                                <td><b>วันทำประกันภัย</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_f_insure); ?></td>
                                <td><b>ประกันภัยหมดอายุ</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->date_e_insure); ?></td>
                            </tr>

                            <?php
                            $insurer = Insurer::model()->findByPk($model->insurer_id);
                            $insurer_name = '';
                            if ($insurer != null) {
                                $insurer_name = $insurer->name;
                            }
                            ?>
                            <tr>
                                <td><b>บริษัทประกันภัย</b></td>
                                <td colspan='3'><?php echo $insurer_name; ?></td>
                            </tr>

                            <tr>
                                <td><b>เพิ่มเติม</b></td>
                                <td colspan='3'><?php echo $model->comment; ?></td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                
                <br/>
                <?php $baseUrl = Yii::app()->request->baseUrl; ?>
                <fieldset>
                    <legend><i class="fa fa-picture-o"></i> ภาพประกอบ</legend>
                    <?php
                    for ($i = 1; $i < 5; $i++):
                        $imagePath = Car::model()->getImagePath($model->id, "picture$i");
                        ?>
                        <div class="fileinput fileinput-new" data-provides="fileinput" style="margin-left:5px;">
                            <div class="fileinput-new thumbnail div-image-center">
                                <a href='<?php echo $imagePath; ?>' class='fancybox' rel="gallery1" title='ภาพประกอบรถ <?php echo $i; ?>'>
                                    <img src="<?php echo $imagePath; ?>" alt="ภาพประกอบรถ <?php echo $i; ?>" class="img-responsive">
                                </a>
                            </div>
                        </div>
                    <?php endfor; ?>
                </fieldset>

            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
    $(function () {
        $(".fancybox").fancybox();
    });
</script>