<?php
$this->pageTitle = Yii::app()->name . ' รายละเอียดการจอง';

$newORedit = ($model->id == '') ? 'เพิ่ม' : 'แก้ไข';
$this->breadcrumbs = array(
    'สอบถามรายการจองใช้รถ' => array('/query'),
    'รายละเอียดการจอง'
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';
?>

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดการจอง</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $carRow = Car::model()->getCarDetail($model->car_id);
                $carDetail = $carRow['code'] . ", " . $carRow['cartype_name'] . ", " . $carRow['brand_name'] . ", " . $carRow['oil_name'];

                $imagePath = Car::model()->getImagePath($model->car_id, "picture1");
                ?>
                <div class="row" style="margin-bottom:0px">
                    <div class="col-sm-3">
                        <div class="thumbnail">
                            <img src="<?php echo $imagePath; ?>" class="img-responsive">
                        </div>
                    </div>
                    <div class="col-sm-9">
                        <div>
                            <div class="pull-left">
                                <h3 class="name" style="margin-top: 5px"><?php echo $carRow['code']; ?></h3>
                            </div>
                            <div class='clearfix'></div>
                        </div>
                        <p style="font-size:14px"><?php echo $carRow['cartype_name'] . ", " . $carRow['brand_name'] . ", " . $carRow['oil_name']; ?></p>
                        <p>
                            <strong>วันที่ใช้รถ </strong> <?php echo MyDate::dateThaiShort($model->start_date) . " เวลา " . date("H:i", strtotime($model->start_date)); ?>
                            <strong>&nbsp;&nbsp;ถึงวันที่&nbsp;&nbsp;</strong> <?php echo MyDate::dateThaiShort($model->end_date) . " เวลา " . date("H:i", strtotime($model->end_date)); ?>
                        </p>
                    </div>
                </div>

                <div class="table-responsive">
                    <table class='table'>
                        <tbody>
                            <tr>
                                <td width='130'><b>เลขที่ใบจอง</b></td>
                                <td width='25%'><?php echo $model->docno; ?></td>
                                <td width='130'><b>วันที่เวลา</b></td>
                                <td><?php echo MyDate::dateThaiLong($model->docdate) . " <b>เวลา</b> " . $model->doctime; ?></td>
                            </tr>
                            <tr>
                                <td><b>จองใช้รถเพื่อ</b></td>
                                <td colspan="3"><?php echo $model->working; ?></td>
                            </tr>
                            <tr>
                                <td><b>สถานที่ไป</b></td>
                                <td colspan="3">
                                    <?php
                                    $address = ($model->tumbol != '') ? " <b> ตำบล </b>$model->tumbol" : '';
                                    $address .= ($model->aumphur != '') ? " <b> อำเภอ </b>$model->aumphur" : '';
                                    $address .= ($model->province != '') ? " <b> จังหวัด </b>$model->province" : '';
                                    echo $model->address . $address;
                                    ?>
                                </td>
                            </tr>
                            <tr>
                                <td><b>ใช้สำหรับแผนก</b></td>
                                <td>
                                    <?php
                                    $depart = Depart::model()->findByPk($model->depart_id);
                                    if ($depart != null) {
                                        echo $depart->name;
                                    }
                                    ?>
                                </td>
                                <td><b>จำนวนผู้โดยสาร</b></td>
                                <td><?php echo $model->passenger_amount; ?></td>
                            </tr>
                            <tr>
                                <td><b>รายชื่อผู้โดยสาร</b></td>
                                <td colspan="3"><?php echo $model->passenger_name; ?></td>
                            </tr>
                            <tr>
                                <td><b>เอกสารอ้างอิง</b></td>
                                <td><?php echo $model->docref; ?></td>
                                <td><b>พนักงานขับรถ</b></td>
                                <td>
                                    <?php
                                    $driver = Driver::model()->findByPk($model->driver_id);
                                    if ($driver != null) {
                                        echo $driver->title . $driver->firstname . " " . $driver->surname;
                                    }
                                    ?>
                                </td>
                            </tr>
                            <tr>
                                <td><b>ผู้ขอใช้</b></td>
                                <td><?php echo $model->person_name; ?></td>
                                <td><b>โทรศัพท์ติดต่อ</b></td>
                                <td><?php echo $model->tel; ?></td>
                            </tr>
                            <tr>
                                <td><b>อัตราค่าเช่า</b></td>
                                <td><?php echo number_format($model->car_rate, 2); ?> <b> บาท:นาที</b></td>
                                <td><b>ค่าเช่าสทุธิ</b></td>
                                <td><?php echo number_format($model->car_money, 2); ?> <b> บาท</b></td>
                            </tr>
                            <tr>
                                <td><b>เพิ่มเติม</b></td>
                                <td colspan='3'><?php echo nl2br($model->comment); ?></td>
                            </tr>
                        </tbody>
                    </table>

                    <h4>ไฟล์แนบ</h4>
                    <?php
                    $baseUrl = Yii::app()->request->baseUrl;
                    $irowFile = 0;
                    $ret = '<ol>';
                    for ($i = 1; $i < 3; $i++) {
                        $fieldName = "file$i" . "_name";
                        $fileRealName = "file$i";
                        if (Booking::model()->getFileExist($model->id, "file$i")) {
                            $irowFile++;
                            $ret .= "<li><a href='$baseUrl/fileupload/booking/" . $model->$fileRealName . "' target='_blank'>" . $model->$fieldName . "</a></li>";
                        }
                    }
                    $ret .= "</ol>";
                    if ($irowFile > 0) {
                        echo $ret;
                    } else {
                        echo "<div class='text-muted'><i>=== ไม่มีไฟล์แนบ ===</i></div>";
                    }
                    ?>
                </div>

            </div>  <!-- end content -->
        </div>  <!-- block-flat -->
    </div>
</div>