<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/duallistbox/bootstrap-duallistbox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/duallistbox/jquery.bootstrap-duallistbox.js');

$this->pageTitle = Yii::app()->name . ' รายงานสรุปจำนวนการใช้รถ-ตามพนักงานขับรถ';
$this->breadcrumbs = array(
    'รายงาน' => array('/reportpage'),
    'รายงานสรุปจำนวนการใช้รถ-ตามพนักงานขับรถ',
);
?>
<div class="row">
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-book"></i></span>
                <h2>รายงานสรุปจำนวนการใช้รถ-ตามพนักงานขับรถ</h2>	
                <div class="widget-toolbar">
                    <a href="javascript:void(0);" onclick='preview(1);' class="btn btn-xs btn-success"><img src='<?php echo Yii::app()->request->baseUrl; ?>/img/page_white.png'/> แสดงรายงาน</a>
                    <a href="javascript:void(0);" onclick='preview(2);' class="btn btn-xs btn-success"><img src='<?php echo Yii::app()->request->baseUrl; ?>/img/page_pdf.png'/> แสดงรายงาน PDF</a>
                    <a href="javascript:void(0);" onclick='preview(3);' class="btn btn-xs btn-success"><img src='<?php echo Yii::app()->request->baseUrl; ?>/img/page_excel.png'/> ส่งออกเป็น Excel</a>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class="row">
                    <div class='col-md-12 form-horizontal'>

                        <form action="<?php echo Yii::app()->createUrl('report/rptcarwork/driverSummaryPreview'); ?>" method="post" id="myform" target="_blank">
                            <input type="hidden" id="report_file" name="report_file" value="0"/> <!-- สำหรับระบุว่าจะออกเป็น hmtl, pdf หรือ excel -->
                            <div class='form-group'>
                                <label class="col-sm-2 col-md-2 control-label">จากวันที่ใช้รถ<span class="required">*</span></label>
                                <div class="col-sm-4 col-md-3">
                                    <div class="input-group date">
                                        <input class="form-control" size="16" type="text" id="start_date" name="start_date" placeholder="วว/ดด/ปี พ.ศ." required="true" value='<?php echo $start_date; ?>'>
                                        <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                                    </div>
                                </div>
                            </div>

                            <div class='form-group'>
                                <label class="col-sm-2 col-md-2 control-label">ถึงวันที่<span class="required">*</span></label>
                                <div class="col-sm-4 col-md-3">
                                    <div class="input-group date">
                                        <input class="form-control" size="16" type="text" id="end_date" name="end_date" placeholder="วว/ดด/ปี พ.ศ." required="true" value='<?php echo $end_date; ?>'>
                                        <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                                    </div>
                                </div>
                            </div>

                            <div class='form-group'>
                                <label class="col-sm-2 col-md-2 control-label">สถานะงาน</label>
                                <div class="col-sm-10 col-md-10">
                                    <label class="radio-inline" style='padding-left:0px'> <input type="radio" name="status" class="icheck" value='99' checked="true"> ทุกสถานะ</label>
                                    <label class="radio-inline" style='padding-left:0px;margin-left: 5px'> <input type="radio" name="status" class="icheck" value='0' > อยู่ระหว่างใช้</label> 
                                    <label class="radio-inline" style='padding-left:0px;margin-left: 5px'> <input type="radio" name="status" class="icheck" value='1' > เสร็จงาน/คืนรถ</label> 
                                </div>
                            </div>

                            <hr/>
                            <div class="row">
                                <div class="col-md-12">
                                    <?php
                                    $drivers = Driver::model()->findAll(array('order' => 'firstname asc'));
                                    ?>
                                    <select multiple="multiple" size="10" name="duallistbox_driver[]" class="list_driver">
                                        <?php
                                        foreach ($drivers as $r) {
                                            $tel = ($r->tel != '') ? " ($r->tel)" : '';
                                            echo "<option value='$r->id'>" . $r->title . $r->firstname . " " . $r->surname . " $tel</option>";
                                        }
                                        ?>
                                    </select>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>
            </div>

        </div>

    </div>
</div>

<script type='text/javascript'>
    $(function () {

        $('#myform').validate({ignore: ":hidden:not(select)"});

        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            orientation: "top auto",
            format: "dd/mm/yyyy"
        });

        var list_driver = $('.list_driver').bootstrapDualListbox({
            nonSelectedListLabel: 'พนักงานขับรถ',
            selectedListLabel: 'พนักงานขับรถที่ต้องการ (ไม่เลือกหากต้องการพิมพ์ทุกคน)',
            preserveSelectionOnMove: 'ย้าย',
            moveOnSelect: false,
            filterTextClear: 'แสดงทั้งหมด',
            filterPlaceHolder: 'กรองพนักงานขับรถที่ต้องการ'
        });

    });

    function preview(report_file) {
        $('.list_driver').bootstrapDualListbox('refresh', true);
        $('#report_file').val(report_file);
        $('#myform').submit();
    }
</script>