<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' อัพเดทโปรแกรม';
$this->breadcrumbs = array(
    'อัพเดทโปรแกรม'
);

$classLabel = 'col-sm-3 col-md-3 control-label';
$classDiv = 'col-sm-9 col-md-9';
?>

<?php if (Yii::app()->user->hasFlash('success')): ?>
    <script type="text/javascript">
        $(function () {
            bootbox.alert("<div class='alert alert-success'><span class='fa fa-smile-o fa-2x'></span> <?php echo Yii::app()->user->getFlash('success'); ?></div>");
        });
    </script>
<?php endif; ?>

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">
        <div class="tab-container">
            <ul class="nav nav-tabs">
                <li class="active"><a href="#tab1" data-toggle="tab">อัพเดทอัตโนมัติ</a></li>
                <li><a href="#tab2" data-toggle="tab">อัตเดทด้วยตัวเอง</a></li>
            </ul>
            <div class="tab-content" style='margin-bottom:10px;'>
                <div class="tab-pane active cont" id="tab1">
                    <?php
                    $form = $this->beginWidget('CActiveForm', array(
                        'id' => 'myform',
                        'enableClientValidation' => false,
                        'enableAjaxValidation' => false,
                        'htmlOptions' => array(
                            'class' => 'form-horizontal',
                        ),
                        'action' => Yii::app()->createUrl('updates/update'), //<- your form action here
                    ));

                    $ret = '';
                    if (!function_exists('curl_version')) {
                        $ret.="<li>library <strong>cURL</strong> ยังไม่ถูกติดตั้งบน Server</i>";
                    }

                    if ($ret != '') {
                        echo "<div class='alert alert-danger nomargin'><strong>คุณจะไม่สามารถอัพเดทโปรแกรมได้เนื่องจาก</strong><ul>$ret</ul></div>";
                    }
                    ?>

                    <div class="row" id="divProgress" style="display:none">
                        <div class="col-md-12">
                            <div class="progress progress-striped active">
                                <div style="width: 80%" class="progress-bar progress-bar-info">กำลังอัพเดทโปรแกรม กรุณารอสักครู...</div>
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-2 control-label">เวอร์ชันปัจจุบัน<span class="required">*</span></label>
                        <div class="col-md-5">
                            <input type='text' id='verson_old' name='verson_old' value='<?php echo Yii::app()->params['versionText']; ?>' class="form-control" autofocus="true" readonly="true"/>
                        </div>
                    </div>

                    <div class='clearfix'></div>

                    <?php if ($ret == ''): ?>
                        <div class="form-actions form-actions-gt">
                            <div class="row no-margin">
                                <button type="button" class="btn btn-default btn-lg" onclick="checkVersion();">
                                    <i class="fa fa-cloud"></i>
                                    ตรวจหาเวอร์ชันใหม่
                                </button>
                            </div>
                        </div>
                    <?php endif; ?>

                    <?php $this->endWidget(); ?>
                </div>

                <div class="tab-pane cont" id="tab2">
                    <?php
                    $form = $this->beginWidget('CActiveForm', array(
                        'id' => 'myformManual',
                        'enableClientValidation' => false,
                        'enableAjaxValidation' => false,
                        'htmlOptions' => array(
                            'class' => 'form-horizontal',
                        ),
                        'action' => Yii::app()->createUrl('updates/updateManual'), //<- your form action here
                    ));
                    ?>

                    <div class="row" id="divProgress" style="display:none">
                        <div class="col-md-12">
                            <div class="progress progress-striped active">
                                <div style="width: 80%" class="progress-bar progress-bar-info">กำลังอัพเดทโปรแกรม กรุณารอสักครู...</div>
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-2 control-label">เวอร์ชันปัจจุบัน<span class="required">*</span></label>
                        <div class="col-md-5">
                            <input type='text' name='verson_old' value='<?php echo Yii::app()->params['versionText']; ?>' class="form-control" autofocus="true" readonly="true"/>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-2 control-label">เวอร์ชันฐานข้อมูล<span class="required">*</span></label>
                        <div class="col-md-5">
                            <input type='text' id='verson_db' name='verson_db' value='<?php echo $model->en5; ?>' class="form-control" readonly="true"/>
                        </div>
                    </div>

                    <div class='clearfix'></div>

                    <?php if ($ret == ''): ?>
                        <div class="form-actions form-actions-gt">
                            <div class="row no-margin">
                                <button type="button" class="btn btn-default btn-lg" onclick="updateManual();">
                                    <i class="fa fa-play"></i>
                                    เริ่มอัพเดทด้วยตนเอง
                                </button>
                            </div>
                        </div>
                    <?php endif; ?>

                    <?php $this->endWidget(); ?>
                </div>
            </div>
        </div>

    </div>
</div>

<script type='text/javascript'>
    function checkVersion() {
        //loadingStatic();
        $.ajax({
            url: "<?php echo Yii::app()->createUrl('updates/ajaxCheck') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                if (data.msg == '0') {
                    bootbox.alert(data.msgText);
                } else {
                    bootbox.confirm('<div class="alert alert-info no-margin"><span class="fa fa-bell-o fa-2x"></span> <strong>ตรวจพบเวอร์ชันใหม่..</strong>คุณต้องการอัพเดทโปรแกรมทันทีใช่หรือไม่!!<br/>การอัพเดทอาจใช้เวลานานขึ้นอยู่กับความเร็วของ Internet</div>', function (result) {
                        if (result) {
                            $('#divProgress').show();
                            $.ajax({
                                url: "<?php echo Yii::app()->createUrl('updates/ajaxUpdate') ?>",
                                type: 'POST',
                                dataType: 'json',
                                success: function (data) {
                                    bootbox.alert('อัพเดทเสร็จสมบูรณ์' + data.msgText);
                                    location.reload();
                                },
                                error: function () {
                                    bootbox.alert(artalert('warning', 'ไม่สามารถอัพเดทได้...ลองตรวจสอบการเชื่อมต่ออินเตอร์เน็ต<br/>หรือลองอัพเดทใหม่อีกครั้ง'));
                                }
                            });
                        }
                    });
                }
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถเชื่อมต่อกับ Server ของ GoodlyThink ได้...กรุณาลองใหม่อีกครั้ง !!'));
            }
        });
        return true;
        //$('#myform').submit();
    }

    function updateManual() {
        $('#divProgress').show();
        $.ajax({
            url: "<?php echo Yii::app()->createUrl('updates/ajaxUpdateManual') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                bootbox.alert('อัพเดทเสร็จสมบูรณ์' + data.msgText);
                location.reload();
            },
            error: function () {
                bootbox.alert(artalert('warning', 'ไม่สามารถอัพเดทได้...ลองตรวจสอบการเชื่อมต่ออินเตอร์เน็ต<br/>หรือลองอัพเดทใหม่อีกครั้ง'));
            }
        });
        return true;
    }
</script>